import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { LoginComponent } from './pages/login/login.component';
import { AuthLoggedIn, AuthGuard, AuthLoad, AuthGuardWithRefresh } from './core/auth-guard.service';
import { PortalComponent } from './pages/portal/portal.component';
import { MainComponent } from './pages/main/main.component';
import { ChangePasswordComponent } from './pages/changepwd/changepwd.component';
// import { MainAComponent } from './pages/main-a/main-a.component';
import { MainIComponent } from './pages/main-i/main-i.component';
// import { MainJComponent } from './pages/main-j/main-j.component';
// import { MainKComponent } from './pages/main-k/main-k.component';
// import { MainLComponent } from './pages/main-l/main-l.component';
// import { MainMComponent } from './pages/main-m/main-m.component';
// import { MainNComponent } from './pages/main-n/main-n.component';
// import { ReportPopupComponent } from './pages/report-popup/report-popup.component';

// import { VdmComponent } from './pages/vdm/vdm.component';
// import { PerformanceComponent } from './pages/performance/performance.component';
// import { ManagementComponent } from './pages/management/management.component';
// import { QVocComponent } from './pages/qvoc/qvoc.component';
// import { SyscusCommentComponent } from './pages/sys-cus-comment/sys-cus-comment.component';
import { MainOComponent } from './pages/main-o/main-o.component';
// import { BPCSILocalSurvayComponent } from './pages/BP-CSI-local-survay/BP-CSI-local-survay.component';
// import { DealerIComponent } from './pages/dealer-i/dealer-i.component';
// import { DealerComponent } from './pages/dealer/dealer.component';
// import { DealerOComponent } from './pages/dealer-o/dealer-o.component';
//import { MenuDemoComponent } from './pages/demo/menu-demo/menu-demo.component';
const routes: Routes = [
  {
    path: '',
    redirectTo: 'login',
    pathMatch: 'full'
  },
  {
    path: 'login',
    component: LoginComponent,
    canActivate: [AuthLoggedIn]
  },
  {
    path: 'portal',
    redirectTo: 'main',
    canActivate: [AuthGuard]
  },
  {
    path: 'main',
    component: MainComponent,
    canActivate: [AuthGuard]
  },
  // {
  //   path: 'main-a',
  //   component: MainAComponent,
  //   canActivate: [AuthGuard]
  // },
  {
    path: 'main-i',
    component: MainIComponent,
    canActivate: [AuthGuard]
  },
  // {
  //   path: 'main-j',
  //   component: MainJComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'main-k',
  //   component: MainKComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'main-l',
  //   component: MainLComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'main-m',
  //   component: MainMComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'main-n',
  //   component: MainNComponent,
  //   canActivate: [AuthGuard]
  // },
  {
    path: 'main-o',
    component: MainOComponent,
    canActivate: [AuthGuard]
  },
  // {
  //   path: 'vdm',
  //   component: VdmComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'performance',
  //   component: PerformanceComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'dealer',
  //   component: DealerComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'dealer-i',
  //   component: DealerIComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'dealer-o',
  //   component: DealerOComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'management',
  //   component: ManagementComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'qvoc',
  //   component: QVocComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'report-popup',
  //   component: ReportPopupComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'sys-cus-comment',
  //   component: SyscusCommentComponent,
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'BP-CSI-local-survay',
  //   component: BPCSILocalSurvayComponent,
  //   canActivate: [AuthGuard]
  // },
  //{
  //  path: 'demo',
  //  component: MenuDemoComponent,
  //  canActivate: [AuthGuard]
  //},
  // {
  //   path: 'Demo',
  //   loadChildren: './modules/demo/demo.module#DemoModule',
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'DhAndRpt',
  //   loadChildren: './modules/dh-and-rpt/dh-and-rpt.module#DhAndRptModule',
  //   canActivate: [AuthGuard]
  // },
  // {
  //   path: 'csm',
  //   loadChildren: './modules/csm/csm.module#CsmModule',
  //   canActivate: [AuthGuard]
  // },
  {
    path: 'report',
    loadChildren: './modules/report/report.module#ReportModule',
    canActivate: [AuthGuard]
  },

];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule],
  providers: [AuthGuard]
})
export class AppRoutingModule { }
