import { Component, OnInit, EventEmitter, Input, SimpleChanges, OnChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { CustomDialogComponent } from 'src/app/components/shared/dialog/dialog.component';

@Component({
  selector: 'circle',
  templateUrl: './circle.component.html',
  styleUrls: ['./circle.component.css']
})
export class CircleComponent implements OnInit, OnChanges {
  private FY: any;
  constructor(
    private http: HttpService,
    private dialog: MatDialog
  ) { }

  // @Input() DataMonth: string;
  @Input() DATA_MONTH: string;
  private headerSSI: any;
  private headerCSI: any;
  public success: boolean = false;
  private dataSSI: any;
  private dataCSI: any;
  public dataCircle: any;
  public circleMode: string;
  public showAs: string;
  public showContent: boolean = false;
  public showContent2: boolean = false;
  public dataLegend: any;
  public dataPayment: any;
  public dateDefualt: string;
  public config: any;
  
  private targerSSI: string;
  private Data_DetailSSI: any
  private Header_DetailSSI: any
  private targerCSI: string;
  private Data_DetailCSI: any
  private Header_DetailCSI: any
  private showTableDialog: boolean = false
  private showChartDialog: boolean = false
  private ShowTable: boolean;

  private TypeData: string;
  private TypeChart: string;
  private showLine: boolean;

  private Header: string;
  private SERVICE_NAME: string;

  public totalOutlet: number;

  private FiledList =
    [
      { Title: 'No. of outlet - Total', Field: 'TOTAL' },
      { Title: 'No. of outlet - Passed', Field: 'OUTLET_PASS' },
      { Title: 'No. of outlet - Not passed', Field: 'OUTLET_FAIL' },
      { Title: '%Outlet - Passed', Field: 'PERCENT_PASS' },
      { Title: '%Outlet - Not passed', Field: 'PERCENT_FAIL' },
      { Title: 'Summary by FY', Field: 'VIEW_CHART' },
    ]

  ngOnInit(): void {

    this.config = {
      minDate: '201905',
      maxDate: '201905',
      ShowTwoPicker: false
    }

    setTimeout(() => this.showContent = true, 1000, this.showContent2 = true, 1000);
    //let d = new Date()
    // this.DATA_MONTH = this.getFormateDate()
    // this.DataMonth = this.getFormateDate()
    this.dataSSI = [];
    this.dataCSI = [];
    this.dataCircle = [];
    this.dataPayment = [];
    this.circleMode = 'SSI';
    this.showAs = 'unit';
    this.GetData()

  }
  ngOnChanges(changes: SimpleChanges): void {
    if (!changes["DATA_MONTH"].isFirstChange()) {
      console.log('this.DATA_MONTH ' + this.DATA_MONTH);
      this.GetData();
    }

  }
   
  private GetData() {
    //console.log('this.DATA_MONTH 2 : ' + this.DATA_MONTH);
    this.http.get('System', 'Get_DSB_SSI_Qualify_Monthly', this.DATA_MONTH)
      .subscribe(result => {
        this.dataSSI = result.Table;
        this.totalOutlet = this.dataSSI[0].TOTAL;
        this.CircleDataChange(this.circleMode, this.showAs);
      })

    this.http.get('System', 'Get_DSB_CSI_Qualify_Monthly', this.DATA_MONTH)
      .subscribe(result => {
        this.dataCSI = result.Table;
         
        this.CircleDataChange(this.circleMode, this.showAs);
      })

    this.http.get('System', 'Get_DSB_Header', this.DATA_MONTH)
      .subscribe(result => {
        this.headerSSI = this.CreateHeader(result.Table[0])
        this.headerCSI = this.CreateHeader(result.Table1[0])
        this.success = true
      })
  }

  public CircleDataChange(mode, pShow) {
    this.dataCircle = [];
    if (mode == 'SSI') {
      this.dataCircle = this.dataSSI;
      this.circleMode = mode;

    } else if (mode == 'CSI') {
      this.dataCircle = this.dataCSI;
      this.circleMode = mode;
    }
    this.showAs = pShow;
  }

  CreateHeader(data) {
    let newData = [];
    for (var key in data) {
      newData.push(data[key])
    }
    return newData
  }

  DateChange(date) {
    this.DATA_MONTH = date;
    this.GetData();
  }


  getFormateDate() {

    let _date = new Date();
    let day = _date.getDate();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;

    if (day >= 15) {
      //month - 1; 
      month = month - 1;
      if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }
    else {
      month = month - 2;
      if (month == -1) {
        month = 11;
        year = year - 1;
      } else if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }

    let newMonth = month.toString().length < 2 ? 0 + '' + month : month
    this.dateDefualt = year + '-' + month + '-01';

    return year + '' + newMonth

  }

  showDetailSSI(data, FIELD) {

    //console.log('FIELD :' + FIELD);
    //console.log('data.NAME :' + data.NAME);

    if (FIELD != 'VIEW_CHART') {
      this.http.get('System', 'Get_DSB_SSI_Qualify_Monthly_Detail', data.NAME, FIELD, this.DATA_MONTH)
        .subscribe(result => {
          this.Data_DetailSSI = result.Table
          this.Header_DetailSSI = result.Table1
          this.targerSSI = result.Table[0].Target_Score
          this.showTableDialog = true
          this.openDialog(this.Data_DetailSSI,
            this.Header_DetailSSI,
            this.targerSSI,
            this.ShowTable,
            this.TypeData,
            this.TypeChart,
            this.showLine,
            this.Header,
            this.SERVICE_NAME,
            data.Header + ' - ' + FIELD
          )
        })
    } else {
      this.ShowTable = data.SHOW_TABLE
      this.TypeData = data.TypeData
      this.TypeChart = data.TypeChart
      this.showLine = data.SHOW_LINE
      this.Header = data.Header
      this.SERVICE_NAME = data.SERVICE_NAME
      this.showChartDialog = true
      this.openDialog(this.Data_DetailSSI,
        this.Header_DetailSSI,
        this.targerSSI,
        this.ShowTable,
        this.TypeData,
        this.TypeChart,
        this.showLine,
        this.Header,
        this.SERVICE_NAME,
        '')
    }
  }
  showDetailCSI(data, FIELD) {
    if (FIELD != 'VIEW_CHART') {
      this.http.get('System', 'Get_DSB_CSI_Qualify_Monthly_Detail', data.NAME, FIELD, this.DATA_MONTH)
        .subscribe(result => {

          this.Data_DetailCSI = result.Table
          this.Header_DetailCSI = result.Table1
          this.targerCSI = result.Table[0].Target_Score
          this.showTableDialog = true
          this.openDialog(this.Data_DetailCSI,
            this.Header_DetailCSI,
            this.targerCSI,
            this.ShowTable,
            this.TypeData,
            this.TypeChart,
            this.showLine,
            this.Header,
            this.SERVICE_NAME,
            data.Header + ' - ' + FIELD)

        })
    } else {
      this.ShowTable = data.SHOW_TABLE
      this.TypeData = data.TypeData
      this.TypeChart = data.TypeChart
      this.showLine = data.SHOW_LINE
      this.Header = data.Header
      this.SERVICE_NAME = data.SERVICE_NAME
      this.showChartDialog = true


      this.openDialog(this.Data_DetailSSI,
        this.Header_DetailSSI,
        this.targerSSI,
        this.ShowTable,
        this.TypeData,
        this.TypeChart,
        this.showLine,
        this.Header,
        this.SERVICE_NAME,
        '')

    }

  }

  private animal: any
  openDialog(Data, Header, target, ShowTable, TypeData, TypeChart, showLine, HeaderChart, SERVICE_NAME, pTitle): void {
    if (this.showTableDialog) {
      const dialogRef = this.dialog.open(CustomDialogComponent, {
        width: '1024px',
        maxHeight: '620px',
        data: {
          config: { template: 'Table', Detail: Data, Header: Header, Target: target, Title: pTitle }
        }
      });
      dialogRef.afterClosed().subscribe(result => {
        this.showTableDialog = false
        this.showChartDialog = false
        this.animal = result;
      });
    }
    if (this.showChartDialog) {
      const dialogRef = this.dialog.open(CustomDialogComponent, {
        width: '1000px',
        //height: '600px',
        data: {
          config: {
            template: 'Chart',
            Detail: Data,
            Header: Header,
            Target: target,
            ShowTable: ShowTable,
            TypeData: TypeData,
            TypeChart: TypeChart,
            showLine: showLine,
            HeaderChart: HeaderChart,
            SERVICE_NAME: SERVICE_NAME,
            FY: this.DATA_MONTH.substring(2, 4),
            Title: pTitle,
          }
        }
      });
      dialogRef.afterClosed().subscribe(result => {
        this.showTableDialog = false
        this.showChartDialog = false
      });
    }
  }



}





