import { Component, OnInit, EventEmitter, Input, SimpleChanges, OnChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { CustomDialogComponent } from 'src/app/components/shared/dialog/dialog.component';

@Component({
    selector: 'csm-qualify-monthly',
    templateUrl: './csm-qualify-monthly.component.html',
    styleUrls: ['./csm-qualify-monthly.component.css']
})
export class CsmQualifyMonthlyComponent implements OnInit,OnChanges{
  
    constructor(
        private http: HttpService,
        private dialog: MatDialog
    ) { }

    @Input() DataMonth: string;
    @Input() FY: string;


    private ShowTable: boolean;

    public dateDefualt: string;
    private TypeData: string;
    private TypeChart: string;
    private showLine: boolean;
    private Header: string;
    private id: string;
    private SERVICE_NAME: string;
    private targerSSI: string;
    private Data_DetailSSI: any
    private Header_DetailSSI: any
    private targerCSI: string;
    private Data_DetailCSI: any
    private Header_DetailCSI: any
    public DATA_MONTH: string;
    public success: boolean = false;
    public dataSSI: any;
    public dataVDM: any;
    public dataCSI: any;
    private headerSSI: any;
    private headerCSI: any;
    public config: any;
    private showTableDialog: boolean = false
    private showChartDialog: boolean = false
    private animal: any;
    private forloop = [1, 2, 3, 4, 5, 6, 7, 8, 9]
    public showContent: boolean = false;
    public showContent2: boolean = false;
    private FiledList =
        [
            { Title: 'No. of outlet - Total', Field: 'TOTAL' },
            { Title: 'No. of outlet - Passed', Field: 'OUTLET_PASS' },
            { Title: 'No. of outlet - Not passed', Field: 'OUTLET_FAIL' },
            { Title: '%Outlet - Passed', Field: 'PERCENT_PASS' },
            { Title: '%Outlet - Not passed', Field: 'PERCENT_FAIL' },
            { Title: 'Summary by FY', Field: 'VIEW_CHART' },
        ]

    ngOnInit(): void {  
        this.GetData();
    }

    ngOnChanges(changes: SimpleChanges): void {

        if (!changes["DataMonth"].isFirstChange()) {
            console.log('DataMonth', this.DataMonth)
            this.GetData();      
        }
    }


    openDialog(Data, Header, target, ShowTable, TypeData, TypeChart, showLine, HeaderChart, SERVICE_NAME, pTitle): void {
        if (this.showTableDialog) {
            const dialogRef = this.dialog.open(CustomDialogComponent, {
                width: '1024px',
                maxHeight: '620px',
                data: {
                    config: { template: 'Table', Detail: Data, Header: Header, Target: target, Title: pTitle }
                }
            });
            dialogRef.afterClosed().subscribe(result => {
                this.showTableDialog = false
                this.showChartDialog = false
                this.animal = result;
            });
        }
        if (this.showChartDialog) {
            const dialogRef = this.dialog.open(CustomDialogComponent, {
                width: '1000px',
                //height: '600px',
                data: {
                    config: {
                        template: 'Chart',
                        Detail: Data,
                        Header: Header,
                        Target: target,
                        ShowTable: ShowTable,
                        TypeData: TypeData,
                        TypeChart: TypeChart,
                        showLine: showLine,
                        HeaderChart: HeaderChart,
                        SERVICE_NAME: SERVICE_NAME,
                        FY: this.DATA_MONTH.substring(2, 4),
                        Title: pTitle,
                    }
                }
            });
            dialogRef.afterClosed().subscribe(result => {
                this.showTableDialog = false
                this.showChartDialog = false
            });
        }
    }
    private GetData() {

        this.http.get('System', 'Get_DSB_SSI_Qualify_Monthly', this.DataMonth)
            .subscribe(result => {
                this.dataSSI = result.Table;              
            })

        this.http.get('System', 'Get_DSB_CSI_Qualify_Monthly', this.DataMonth)
            .subscribe(result => {
                this.dataCSI = result.Table;              
            })
        this.http.get('System', 'Get_DSB_Header', this.DataMonth)
            .subscribe(result => {
                this.headerSSI = this.CreateHeader(result.Table[0])
                this.headerCSI = this.CreateHeader(result.Table1[0])
                this.success = true
            })

    }

    showDetailSSI(data, FIELD) {

        if (FIELD != 'VIEW_CHART') {
            this.http.get('System', 'Get_DSB_SSI_Qualify_Monthly_Detail', data.NAME, FIELD, this.DataMonth)
                .subscribe(result => {
                    this.Data_DetailSSI = result.Table
                    this.Header_DetailSSI = result.Table1
                    this.targerSSI = result.Table[0].Target_Score
                    this.showTableDialog = true
                    this.openDialog(this.Data_DetailSSI,
                        this.Header_DetailSSI,
                        this.targerSSI,
                        this.ShowTable,
                        this.TypeData,
                        this.TypeChart,
                        this.showLine,
                        this.Header,
                        this.SERVICE_NAME,
                        data.Header + ' - ' + FIELD
                    )
                })
        } else {
            this.ShowTable = data.SHOW_TABLE
            this.TypeData = data.TypeData
            this.TypeChart = data.TypeChart
            this.showLine = data.SHOW_LINE
            this.Header = data.Header
            this.SERVICE_NAME = data.SERVICE_NAME
            this.showChartDialog = true
            this.openDialog(this.Data_DetailSSI,
                this.Header_DetailSSI,
                this.targerSSI,
                this.ShowTable,
                this.TypeData,
                this.TypeChart,
                this.showLine,
                this.Header,
                this.SERVICE_NAME,
                '')
        }
    }
    showDetailCSI(data, FIELD) {
        if (FIELD != 'VIEW_CHART') {
            this.http.get('System', 'Get_DSB_CSI_Qualify_Monthly_Detail', data.NAME, FIELD, this.DataMonth)
                .subscribe(result => {

                    this.Data_DetailCSI = result.Table
                    this.Header_DetailCSI = result.Table1
                    this.targerCSI = result.Table[0].Target_Score
                    this.showTableDialog = true
                    this.openDialog(this.Data_DetailCSI,
                        this.Header_DetailCSI,
                        this.targerCSI,
                        this.ShowTable,
                        this.TypeData,
                        this.TypeChart,
                        this.showLine,
                        this.Header,
                        this.SERVICE_NAME,
                        data.Header + ' - ' + FIELD)

                })
        } else {
            this.ShowTable = data.SHOW_TABLE
            this.TypeData = data.TypeData
            this.TypeChart = data.TypeChart
            this.showLine = data.SHOW_LINE
            this.Header = data.Header
            this.SERVICE_NAME = data.SERVICE_NAME
            this.showChartDialog = true





            this.openDialog(this.Data_DetailSSI,
                this.Header_DetailSSI,
                this.targerSSI,

                this.ShowTable,
                this.TypeData,
                this.TypeChart,
                this.showLine,
                this.Header,
                this.SERVICE_NAME,
                '')

        }

    }


    CreateHeader(data) {
        let newData = [];
        for (var key in data) {
            newData.push(data[key])
        }
        return newData
    }



}


   


