import { Component, Input, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { CustomDialogComponent } from 'src/app/components/shared/dialog/dialog.component';
import { json } from 'd3';

@Component({
    selector: 'qvoc-cus-comment',
    templateUrl: './qvoc-cus-comment.component.html',
    styleUrls: ['./qvoc-cus-comment.component.css']
})
export class CustomerCommentComponent implements OnInit {
  constructor(
    private http: HttpService,
    private dialog: MatDialog
  ) { }


    @Input() FY: any;
    public DataList: any = []
    public dataSales: any = []
    public dataAfterSales: any = []
    public selectedName: any;
    public data1Total: any = {};
    public data2Total: any = {};
    public dataSalesTotal: any;
    public dataAfterSalesTotal: any;

    public localPath: string = '/report-popup?'
    public FullPath: string;
    public DATA_MONTH: string;



    ngOnInit(): void {
        this.GenDataCusCommentTotal()
        this.ViewData('201904')
        this.data1Total = {};
        this.data2Total = {};
        this.DATA_MONTH = this.GetFormateDate()

    }

    private GetFormateDate() {
        let _date = new Date();
        let year = _date.getFullYear()
        let month = _date.getMonth() + 1;
        let newMonth = month.toString().length < 2 ? 0 + '' + month : month
        return year + '' + newMonth;
    }

    GenDataCusCommentTotal() {

        this.http.get("System", "GetQVOC_Cus_Comment_Total", this.FY)
            .subscribe(res => {
                this.DataList = res.Table;
                console.log(this.DataList, 'this.DataList')
              
            })
    }


    public ViewData(dataMonth) {
        this.selectedName = dataMonth;
        this.http.get('System', 'GetData_QVOC_Cus_Comment', dataMonth)
            .subscribe(res => {
                this.dataSales = res.Table;
                this.dataAfterSales = res.Table1;
                this.SummaryDataList();
                this.SummaryAfterSales();
            })
    }

    public highlightRow(data) {
      return  this.selectedName == data.DATA_MONTHNAME;
    }

   

    public SummaryDataList() {
        this.data1Total.NO_OF_CASE = 0;
        this.data1Total.Value = 0;
       
        this.dataSales.forEach((value) => {
            this.data1Total.NO_OF_CASE = this.data1Total.NO_OF_CASE + value.NO_OF_CASE;
            this.data1Total.Value = this.data1Total.Value + value.Value;
           
        });
    }

    public summarySales() {
        this.dataSalesTotal = 0;
        this.dataSales.forEach((value) => {
            this.dataSalesTotal += value.Value
        });
    }

    public SummaryAfterSales() {
        this.data2Total.NO_OF_CASE = 0;
        this.data2Total.Value = 0;

        this.dataAfterSales.forEach((value) => {
            this.data2Total.NO_OF_CASE = this.data2Total.NO_OF_CASE + value.NO_OF_CASE;
            this.data2Total.Value = this.data2Total.Value + value.Value;

        });
    }

    public summaryAfterSales() {
        this.dataAfterSalesTotal = 0;
        this.dataAfterSales.forEach((value) => {
            this.dataAfterSalesTotal += value.Value
        });
    }

    ReportCus_comment() {

        this.FullPath = origin + this.localPath + 'reportName=' + 'VME_Rpt_VDM_Quick_VOC_Customer_Comment' + '&paraMeterType=' + 'CUSTOM' + '&params=' + this.selectedName;
        window.open(this.FullPath, '_blank');

    }

}

