import { Component, OnInit, OnChanges, SimpleChanges, Input } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';

@Component({
  selector: 'table-card',
  templateUrl: './table-card.component.html',
  styleUrls: ['./table-card.component.css']
})
export class TableCardComponent implements OnInit, OnChanges {

  constructor(
    private http: HttpService,
    private dialog: MatDialog
  ) { }

  @Input() FY: any;
  public data1: any = [];
  //public data2: any = [];
  //public data3: any = [];
  //public data4: any = [];
  //public data5: any = [];
  //public data6: any = [];
  //public data7: any = [];
  //public data8: any = [];
  //public data9: any = [];
  //public data10: any = [];
  //public data11: any = [];
  public data12: any = [];
  selectedRow: Number;
  setClickedRow: Function;
  public data1Total: any = {};
  private DATA_MONTH: string;
  public selectrow;
  public selectedName: any;

  ngOnInit(): void {

    //this.FY = this.GetCurrentFY();
    this.FY = '19'
    this.DATA_MONTH = this.GetFormateDate();
    this.GetData();
    this.ViewData(this.DATA_MONTH);

  }

  ngOnChanges(changes: SimpleChanges): void {
    if (!changes["FY"].isFirstChange()) {
      this.GetData();
    }
  }

  private GetCurrentFY() {
    let _date = new Date();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;

    if (month <= 3) {
      year = year - 1;
    }
    return year - 2000;
  }

  private GetData() {

    this.http.get('System', 'Get_RPT_VDM_SSI_Unit_Confirm', this.FY)
      .subscribe(result => {
        this.data1 = result.Table;
        this.Summary();
        let find = this.data1.find(x => x.DATA_MONTH == this.DATA_MONTH)
        this.selectedName = find.DATA_MONTHNAME;

      })
  }

  private Summary() {

    this.data1Total.RS = 0;
    this.data1Total.DELIVERED = 0;
    this.data1Total.CONFIRMED = 0;
    this.data1Total.REMAIN = 0;

    this.data1.forEach((value) => {
      //console.log(value.RS);
      this.data1Total.RS = this.data1Total.RS + value.RS;
      this.data1Total.DELIVERED = this.data1Total.DELIVERED + value.DELIVERED;
      this.data1Total.CONFIRMED = this.data1Total.CONFIRMED + value.CONFIRMED;
      this.data1Total.REMAIN = this.data1Total.REMAIN + value.REMAIN;
    });
 
  }

  public ViewData(dataMonth) {

    this.http.get('System', 'GetSsiUnitMonth', this.FY, dataMonth)
      .subscribe(res => {
        this.data12 = res.Table[0];
        this.selectedName = this.data12.DATA_MONTHNAME;
      })

  }

  public highlightRow(data) {
    this.selectedName = data.DATA_MONTHNAME;
  }

  public GetFormateDate() {
    let _date = new Date();
    let day = _date.getDate();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;

    if (day >= 15) {

      month = month - 1;
      if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }
    else {
      month = month - 2;
      if (month == -1) {
        month = 11;
        year = year - 1;
      } else if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }

    let newMonth = month.toString().length < 2 ? 0 + '' + month : month

    return year + '' + newMonth

  }



}





