import { Component, OnInit, ViewChild, Input, OnChanges, SimpleChanges } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { MatPaginator } from '@angular/material/paginator';
import { MatTableDataSource } from '@angular/material/table';
import { Globals } from 'src/app/core/global';


@Component({
    selector : 'vdm-accrued',
    templateUrl:'./vdm-accrued.component.html',
    styleUrls :['./vdm-accrued.component.css']
})
export class VdmAccruedComponent implements OnInit,OnChanges{

    constructor(
        private http : HttpService,
        private globals: Globals
    ){

    }
    @Input() FY : string;
    @ViewChild(MatPaginator, {static: true}) paginator: MatPaginator;
    public dataSource : any;
  public displayedColumns: string[] = ['Month', 'Outlet ID', 'Dealer Name', 'Branch Name','Amount'];
    public HeaderList : any = ["Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec","Jan", "Feb", "Mar"];
    public DataList : any = []

    ngOnInit() : void{

        this.GenData()
    }

    ngOnChanges(changes: SimpleChanges): void {
       this.GenData()
    }

    GenData(){
        this.http.get("System","GetVDM_Accrued",this.FY)
        .subscribe(res =>{
            this.DataList = res.Table;
            this.dataSource = new MatTableDataSource<any>(res.Table);
            this.dataSource.paginator = this.paginator;
        })
    }


    Export(){
        this.http.Export("System","Export",this.DataList)
        .subscribe(res =>{
            this.WriteContents(res)
        })
    }

    WriteContents(content) {
        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type });
        a.href = URL.createObjectURL(file);
        a.download = "List_of_oulet_cannot_pay" + '_' + this.globals.CurrentDate() + ".xlsx";
        
        a.click();
      }
}
