import { Component, OnInit, OnChanges, Input, SimpleChanges } from "@angular/core";
import * as D3 from 'd3';


@Component({
    selector:'guage-iiii-chart',
    templateUrl: './guage-iiii-chart.component.html',
    styleUrls: ['./guage-iiii-chart.component.css']
})

export class GuageIIIIChartComponent implements OnInit,OnChanges{

  @Input() ID : string ;
  @Input() Value : number = 90
  @Input() Title : string = 'Simple'
  @Input() Colors: string = '#aadf62'
  //@Input() SelectMonth: string = '';
  //@Input() SelectYear: string = '';
  @Input() pMonth: string = '';
  //@Input() ChartLength : string = ''

    constructor(){

    }

    private d3 : any = D3;
    private group : any;
    private foreground : any;
    private radiusScaleB : any;
    private arc : any;
    private background : any;
    private month: any;
    ngOnInit(){

    }
    
    ngOnChanges(changes: SimpleChanges): void {


      if (!changes["Value"].isFirstChange()) {
        //this.CreateDomain()
        this.Update(this.Value)
      }

    }
  

   
  ngAfterViewInit() {
    this.SetUpchart()
  }


  SetUpchart(){

    const height = 200; 
    const width = 180; 
    const outerRadius = 70; 
    const innerRadius = 50; 

    const svg = this.d3.select('#' + this.ID).append('svg')
    .attr('width', width)
    .attr('height', height)
    .style('background', '#FFFFFF'); 

     this.group = svg.append('g')
    .attr('class', 'group')
    .attr('transform', `translate(${width * 0.5}, ${height * 0.5})`);


    const keduListB = [0,1,2,3,4,5,6,7,8,9,10,11,12]; 
    const keduListS = [0,1,2,3,4,5,6,7,8,9,10,11]; 

    

     this.radiusScaleB = this.d3.scaleLinear().domain([0, this.GenerateMaxDomain(this.Value)]).range([Math.PI * (- 2 / 3), Math.PI * 2 / 3]) 
     const radiusScaleS = this.d3.scaleLinear().domain([0, 11]).range([Math.PI * (- 11 / 18), Math.PI * ( 11 / 18 )]) 

    this.arc = this.d3.arc()
                .innerRadius(innerRadius)
                .outerRadius(outerRadius) 
                .startAngle(this.radiusScaleB(0));

    var arc2 = this.d3.arc()
                .outerRadius(90)
                .innerRadius(80);

        
    //----------------Circle------------------------//         
    
    var defs = svg.append("defs");

    var dropShadowFilter = defs.append('svg:filter')
      .attr('id', 'drop-shadow')
      .attr('filterUnits', "userSpaceOnUse")
      .attr('width', '100%')
      .attr('height', '100%');
    dropShadowFilter.append('svg:feGaussianBlur')
      .attr('in', 'SourceGraphic')
      .attr('stdDeviation', 2)
      .attr('result', 'blur-in');
    dropShadowFilter.append('svg:feColorMatrix')
      .attr('in', 'blur-in')
      .attr('type', 'hueRotate')
      .attr('values', 180)
      .attr('result', 'color-in');
    dropShadowFilter.append('svg:feOffset')
      .attr('in', 'color-in')
      .attr('dx', 1)
      .attr('dy', 1)
      .attr('result', 'the-shadow');
    dropShadowFilter.append('svg:feBlend')
      .attr('in', 'SourceGraphic')
      .attr('in2', 'the-shadow')
      .attr('mode', 'normal');


      // var svgDefs = svg.append('defs');
      // var mainGradient = svgDefs.append('linearGradient')
      //     .attr('id', 'mainGradient');
      // // Create the stops of the main gradient. Each stop will be assigned
      // // a class to style the stop using CSS.
      // mainGradient.append('stop')
      //     .attr('class', 'stop-left')
      //     .attr('offset', '0');

      // mainGradient.append('stop')
      //     .attr('class', 'stop-right')
      //     .attr('offset', '1');


      var gradient = svg.append("defs")
        .append("linearGradient")
          .attr("id", "gradient")
          .attr("x1", "0%")
          .attr("y1", "0%")
          .attr("x2", "100%")
          .attr("y2", "100%")
          .attr("spreadMethod", "pad");

      gradient.append("stop")
          .attr("offset", "0%")
          .attr("stop-color", "#676767")
          .attr("stop-opacity", 1);

      gradient.append("stop")
          .attr("offset", "100%")
          .attr("stop-color", "#323232")
          .attr("stop-opacity", 1);


      this.group.selectAll("circle1")
      .data([0])
      .enter()
      .append("circle")
      // .classed('filled', true)
      .style("fill", "url(#gradient)")
      .attr("r", outerRadius + 10);

      this.group.selectAll("circle2")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#676767") //4b4b4b
      .style("filter", "url(#drop-shadow)")
      .style("stroke", "#393939")
      .attr("r", 11)
      .attr('transform', `translate(${width - width}, ${(height - height) + 45})`);    

    //-------------------------------------------------//


    //-----------------------Triangle--------------------------//

   var triangles = [{x: width * 0.5,y: height / 1.38}];

    var arcTri = this.d3.symbol().type(this.d3.symbolTriangle);

    var line = svg.selectAll('path')
      .data(triangles)
      .enter()
      .append('path')
      .attr('d', arcTri)
      .attr('fill', '#63b10d')
      // .attr('stroke', '#000')
      .attr('stroke-width', 1)
      .attr('transform', function(d) {
        return "translate(" + d.x + ","+ d.y +")";
      });

    //---------------------------------------------------//


    //---------------------TEXT CURVE---------------------------//

    function getPathData() {
      // adjust the radius a little so our text's baseline isn't sitting directly on the circle
      var r = 100 * 0.95;
      var startX = width/2 - r;
      return 'm' + startX + ',' + (height/2.55) + ' ' +
        'a' + r + ',' + r + ' 0 0 0 ' + (2*r) + ',0';
    }

    svg.append('defs')
        .append('path')
        .attr('d', getPathData)
        .attr('id', 'curvedTextPath')

    
    svg.append('text')
        .attr('text-anchor', 'middle')
        .attr('x', 150)
        .attr('y', 130)      
        .attr('dy', '0.15em')
        .attr('fill', function (d,i){ 
          return '#f05a69'
        })
        // .attr('stroke', '#f05a69') 
        .attr('font-size', '10pt')
        .append('textPath')
        .attr("xlink:href",'#curvedTextPath')
        .text(this.Title)

    //--------------------------------------------------//

   
    //this.group.append('g').attr('class', 'textname') 
    this.group.append('g').attr('class', 'arcs3') // เส้นโค้งสีดำ
    this.group.append('g').attr('class', 'arcs') // เส้นโค้งของข้อมูล
    this.group.append('g').attr('class', 'arcs2') // เส้นโค้งวงนอก
    this.group.append('g').attr('class', 'thin_line') //เส้นบาง
    //this.group.append('g').attr('class', 'value') // value
    this.group.append('g').attr('class', 'show') // TextValue
    this.group.append('g').attr('class', 'Month') // TextMonth-Year
    this.group.append('g').attr('class', 'button') 

     this.group.select('.arcs2').append('path')
        .attr('d', arc2({startAngle: 0,endAngle: 360}))
        .attr('fill', '#d6d6d6')
        .attr('stroke', '#dadada');


     this.foreground = this.group.select('.arcs').append('path')
          .datum({
            endAngle: this.radiusScaleB(0),
            OldValue : 0
          })
          .attr('d', this.arc)
          .attr('fill', this.Colors)
          .attr('stroke', this.Colors)
          //.each(function(d) { this._current = d; });

    this.background  = this.group.select('.arcs3').append('path')
        .datum({
          endAngle: this.radiusScaleB(0),
          OldValue : 0
        })
        .attr('d', this.arc({endAngle: this.radiusScaleB(this.GenerateMaxDomain(this.Value))}))
        .attr('fill', '#000000')
        .attr('stroke', '#000000');



    this.group.select('.thin_line')
        .selectAll('line')
        .data(keduListS)
        .enter()
        .append('line')
        .attr('x1', d => 70 * Math.sin(radiusScaleS(d)))
        .attr('y1', d => 70 * Math.cos(radiusScaleS(d)) * -1)
        .attr('x2', d => 49.5 * Math.sin(radiusScaleS(d)))
        .attr('y2', d => 49.5 * Math.cos(radiusScaleS(d)) * -1)
        .attr('stroke', '#393939')
        .attr('stroke-width', 1.5)

    
    this.group.select('.show')
        .append('text')
        .attr('text-anchor', 'middle')
        .attr('x', 0)
        .attr('y', -5)
        .attr('dy', '0.35em')
        .attr('fill', '#ffffff')
        .attr('stroke', '#ffffff')
        .attr('font-size', '20pt')
      .text(this.Value)

    this.month = this.group.select('.Month')
      .append('text')
      .attr('text-anchor', 'middle')
      .attr('x', 0)
      .attr('y', 24)
      .attr('dy', '0.35em')
      .attr('fill', '#ffffff')
      .attr('stroke', '#ffffff')
      .attr('font-size', '8pt')
      .text(this.pMonth)   

    this.Update(this.Value)

    

  }


  CreateDomain(){


    

   
  }


  Update = number => {


    // this.radiusScaleB.domain([0, this.GenerateMaxDomain(this.Value)])

    // this.background.transition()
    // .duration(100)
    // .attrTween("d", this.arcTweenBack(this.d3,this.GenerateMaxDomain(this.Value),this.radiusScaleB,this.arc))

    this.foreground.transition()
    .duration(2500)
      .attrTween("d", this.arcTween(this.d3, number, this.radiusScaleB, this.texts, this.arc))

    this.month.text(this.pMonth)  
  }

  arcTweenBack(d3,newAngle,radiusScaleB,arc) {         
    return function(d) {    
        var interpolate = d3.interpolate(d.endAngle, radiusScaleB(newAngle));
        //var interpolateText = d3.interpolate(d.OldValue, newAngle);
        return function(t) {
          d.endAngle = interpolate(t);
          d.OldValue = newAngle;         
          return arc(d);
        };
    };
}

   arcTween(d3,newAngle,radiusScaleB,texts,arc) {         
          return function(d) {    
              var interpolate = d3.interpolate(d.endAngle, radiusScaleB(newAngle));
              var interpolateText = d3.interpolate(d.OldValue, newAngle);
              return function(t) {
                d.endAngle = interpolate(t);
                d.OldValue = newAngle;
                texts(interpolateText(t));
                return arc(d);
              };
          };
  }


  texts = text => {
      this.group.select('.show')
      .select('text')
      .attr('text-anchor', 'middle')
      .attr('x', 0)
      .attr('y', 0)
      .attr('dy', '0.35em')
      .attr('fill', '#ffffff')
      .attr('stroke', '#ffffff')
      .attr('font-size', '25pt')
      .text(`${Math.floor(text)}`)
  }


  GenerateMaxDomain(value : number){

    let maxDomain : number = 100

    // if(value <= 100){
    //   maxDomain = 100;
    // }else if ( value <= 500){
    //   maxDomain = 500
    // }else if(value <= 1000){
    //   maxDomain = 1000
    // }

    if(value <= 1000){
      maxDomain = 1000;
    }

    return maxDomain;

  }


}

