import { Component, OnInit, OnChanges, Input, SimpleChanges } from "@angular/core";
import * as D3 from 'd3';


@Component({
    selector:'guage-v-chart',
    templateUrl: './guage-v-chart.component.html',
    styleUrls: ['./guage-v-chart.component.css']
})

export class GuageVChartComponent implements OnInit,OnChanges{

  @Input() ID : string ;
  @Input() Value : number = 5
  @Input() Title : string = 'Simple'
  @Input() Colors : string = '#aadf62'
  @Input() MaxValue: number = 90
  @Input() MaxValueChart: number = 18   //18 or 1.8
  //@Input() ChartLength : string = ''

    constructor(){

    }

    private d3 : any = D3;
    private group : any;
    private foreground : any;
    private radiusScaleB : any;
    private arc : any;
    private background : any;

  ngOnInit() {
    if (!this.Value) {
      this.Value = 0;
    }
    else if (this.Value == null || this.Value === undefined ) {
      this.Value = 0;
    }
    }
    
  ngOnChanges(changes: SimpleChanges): void {

    this.Value = this.Value  || 0
    //if (this.Value == null || this.Value === undefined) {
    //  this.Value = 0;
    //}

      if (!changes["Value"].isFirstChange()) {
        //this.CreateDomain()
        this.Update(this.Value)
    }
   
    }
   
  ngAfterViewInit() {
    this.SetUpchart()
  }

  SetUpchart(){
    const height = 180; 
    const width = 250; 
   let d3 : any = this.d3;

   const svg = this.d3.select('#' + this.ID).append('svg')
   .attr('width', width)
   .attr('height', height)
   .style('background', '#FFFFFF'); 

      var arc, data, padding, steps = 2, r=400/2, pi = Math.PI;
      // padding = 2 * r / 200;
      arc = d3.arc()
        .innerRadius(50)
        .outerRadius(120).startAngle(function(d) { return d.startAngle; })
        .endAngle(function(d) { return d.endAngle; });

      data = d3.range(this.MaxValue).map((d, i) => {
        //i *= steps;
        let color =""
        let Average = this.MaxValue / 3


        if(i < 30){
          color = "#74d8a4"
        }else if(i < (Average * 2)){
          color = "#ffca00"
        }else{
          color = "#ff7a7e"
        }

        return {
          startAngle: i * (pi / this.MaxValue),
          endAngle: (i + 1) * (pi / this.MaxValue),
          fill: color
        };
      });

      this.group = svg.append('g')
      .attr('class', 'group')
      .attr('transform', `translate(${width * 0.5}, ${height * 0.75})`);

      this.group.append('g').attr('class', 'arcs3') 
      this.group.append('g').attr('class', 'needle') //เข็ม

     this.group.select(".arcs3")
          .attr("transform", "rotate(90) scale(-1,1)")
          .selectAll('path')
            .data(data)
            .enter()
            .append('path')
            .attr("d", arc)
            .attr("stroke-width", 1)
            .attr("stroke", function(d) { return d.fill;})
            .attr("fill", function(d) { return d.fill; });

     this.group.select('.needle')
            .append('polygon')
            .attr('points', '0,-5,-1,-5,4,0,1,60,-1,60,-4,0')
            .attr('fill', 'black')
            .attr('transform',`rotate(${90})`)

      //---------------------------------emoji 1------------------------------------------------//
      this.group.selectAll("emoji1")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#ffffff") //4b4b4b
      .style("stroke", "#ffffff")
      .attr("r", 25)
      .attr('transform', `translate(${-75}, ${(-35)})`);    

      this.group.selectAll("eye1")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${-85}, ${(-40)})`); 

      this.group.selectAll("eye2")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${-65}, ${(-40)})`); 


      this.group.selectAll("circle31")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 7)
      .attr('transform', `translate(${-75}, ${(-25)})`);    

      this.group.selectAll("circle41")
      .data([0])
      .enter()
      .append("rect")
      .attr("fill","#ffffff") //4b4b4b
      //.style("stroke", "#ffffff")
      //.attr("r", 9)
      .attr('width', 20)
        .attr('height', 10)
      .attr('transform', `translate(${-85}, ${(-27)})`); 


 

       //---------------------------------------------------------------------------------//

        //----------------------------------emoji 2---------------------------------------------//

      this.group.selectAll("circle2")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#ffffff") //4b4b4b
      .style("stroke", "#ffffff")
      .attr("r", 25)
      .attr('transform', `translate(${-0}, ${(-80)})`);    

      this.group.selectAll("eye12")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${-10}, ${(-85)})`); 

      this.group.selectAll("eye22")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${10}, ${(-85)})`); 

      var line = this.group.selectAll('.lineemoji1')
      .data([0])
      .enter().append('g')
      .attr("class", "lineemoji1")

      line.append('line')
      .attr("x1",  -8)
      .attr("y1", -70.5)
      .attr("x2", 10)
      .attr("y2", -71)
      .attr("fill", "none")
      .attr("stroke-width", 1.5)
      .attr("stroke", "#000000") 

       //---------------------------------------------------------------------------------//


        //----------------------------------emoji 3---------------------------------------------//

      this.group.selectAll("circle3")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#ffffff") //4b4b4b
      .style("stroke", "#ffffff")
      .attr("r", 25)
      .attr('transform', `translate(${75}, ${(-35)})`);    

      this.group.selectAll("eye13")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${85}, ${(-40)})`); 

      this.group.selectAll("eye23")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 2)
      .attr('transform', `translate(${65}, ${(-40)})`); 

      this.group.selectAll("circle33")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#000000") //4b4b4b
      .style("stroke", "#000000")
      .attr("r", 8)
      .attr('transform', `translate(${75}, ${(-30)})`);    

      this.group.selectAll("circle43")
      .data([0])
      .enter()
      .append("circle")
      .attr("fill","#ffffff") //4b4b4b
      .style("stroke", "#ffffff")
      .attr("r", 7.55)
      .attr('transform', `translate(${75}, ${(-35)})`); 



       //---------------------------------------------------------------------------------//

      this.Update(this.Value)
  }



  Update = value => {
    value = value * this.MaxValueChart
    let d3: any = this.d3
    //let texts = this.texts
    
    this.group.select('.needle')
        .transition()
        .duration(2000)
        .ease(this.d3.easeLinear)
        .attrTween('transform', function () {
          this._before = typeof this.getAttribute('transform') == 'string' ? this.getAttribute('transform').match(/\d+/g)[0] : 0;
          this._after = value;
          let interpolate = d3.interpolate(this._before, this._after);
          return function (t) {
            //texts(interpolate(t))
            return `rotate(${interpolate(t)})`
          };
        })
    }






  GenerateMaxDomain(value : number){

    let maxDomain : number = 100

    // if(value <= 100){
    //   maxDomain = 100;
    // }else if ( value <= 500){
    //   maxDomain = 500
    // }else if(value <= 1000){
    //   maxDomain = 1000
    // }

    if(value <= 1000){
      maxDomain = 1000;
    }

    return maxDomain;

  }


}

