import { Component, OnInit, OnChanges, ElementRef, Input, ViewChild, ViewEncapsulation, SimpleChanges } from '@angular/core';
import * as d3 from 'd3';
import { stack } from 'd3';
import { HttpService } from '../../../../core/http.service';
import { first } from 'rxjs/operators';

@Component({
    selector: 'multiple-bar-chart',
    templateUrl: './multiple-bar-chart.component.html',
    styleUrls: ['./multiple-bar-chart.component.css']
})



//*
//<multiple-bar-chart [ID]="'C1'" [dataLegend]="dataLegend" [serviceName]="'GetData'" [FY]="'19'" > </multiple-bar-chart>
//*

export class MultipleBarChartComponent implements OnInit, OnChanges {
    constructor(
        private http: HttpService
    ) { }

    @Input() dataLegend: ChartData[];
    @Input() serviceName: string;
    @Input() serviceName2: string;
    @Input("ID") ID: string;
    @Input() OutletID: string;
    @Input() FY: string;
    @Input() QTR: string;
    //@Input() SP_NAME: string;

    @Input() yAxisMax: number;
    @Input() xAxisMax: number;

    @ViewChild('chart', { static: true }) chartContainer: ElementRef;
    @Input() xScaleSizeChartMultiple: any;
    @Input() yScaleSizeChartMultiple: any;
    @Input() xScaleSizeBarMultiple: any;
    @Input() yScaleSizeBarMultiple: any;
    @Input() yScalelegendValue1: any;
    @Input() yScalelegendValue2: any;
    @Input("chartname") chartname: string;

    private margin = { top: 30, right: 20, bottom: 40, left: 80};
    private width = 580 - this.margin.left - this.margin.right;
    private height = 350 - this.margin.top - this.margin.bottom;
    private changes: any;
    private nodeWidth: any;

    ngOnInit() {

        //this.GetData(this.ID) 
        this.width = this.xScaleSizeBarMultiple
        if (this.width == null)
        {
            this.margin = { top: 30, right: 20, bottom: 40, left: 80 };
            this.width = 580 - this.margin.left - this.margin.right
        }
        this.height = this.xScaleSizeBarMultiple
        if (this.height == null)
        { 
            this.margin = { top: 30, right: 20, bottom: 40, left: 80 };
            this.height = 350 - this.margin.top - this.margin.bottom
        }
    }

    ngOnChanges(changes: SimpleChanges): void {
        //if (!this.GetData || this.data.length == 0) { return; }
        //this.createChart(this.data)
      d3.select("#" + 'multichart' + this.ID).remove();
      this.GetData(this.ID)

        //if (!changes["serviceName"].isFirstChange() )  
        //{
        //        d3.select("#" + 'multichart' + this.ID).remove();
        //        this.GetData(this.ID)
        //}
        //if (!changes["QTR"].isFirstChange()) {
        //    d3.select("#" + 'multichart' + this.ID).remove();
        //    this.GetData(this.ID) 
        //}
        //else if (!changes["FY"].isFirstChange()) {
        //    d3.select("#" + 'multichart' + this.ID).remove();
        //    this.GetData(this.ID)
        //}
    }


    ngAfterViewInit() {

        //this.CreateChart(this.resultData,this.ID)
        //this.GetData(this.ID)
    }
    resultData(resultData: any, ID: string) {
        throw new Error("Method not implemented.");
    }


    GetData(id) {
        if (this.QTR != '') {
            this.http.get("System", this.serviceName, this.FY, this.QTR)
                .subscribe(result => {
                    this.CreateChart(result.Table, id);
                })
        }
        else {
            this.http.get('System', this.serviceName, this.FY)
                .subscribe(result => {
                    this.CreateChart(result.Table, id);
                })
        }
    }

    private CreateChart(resultData, id): void {

        var margin = { top: 30, right: 20, bottom: 40, left: 80 },
            width = 580 - margin.left - margin.right,
            height = 350 - margin.top - margin.bottom;

        width = this.xScaleSizeBarMultiple
        if (width == null) {
            width = 580 - margin.left - margin.right
        }
        height = this.yScaleSizeBarMultiple
        if (height == null) {
            height = 350 - margin.top - margin.bottom
        }
        const legendList = this.dataLegend[0].Legend
        console.log('legendList', legendList)
        const data: any[] = resultData;

        console.log('xxxxxx :', data);

        let datamax: any;
        let datamax2: any;

        datamax = data.map(a => Math.max(a.Value));
        datamax2 = data.map(a => Math.max(a.Value2));
        console.log('loadmax1', datamax)
        console.log('loadmax2', datamax2)

        var l = datamax.length;
        var max1 = -Infinity;
        var i;
        for (i = 0; l > i; i++) {

            if (datamax[i] > max1) {

                max1 = datamax[i];

            }

        }


        var l = datamax2.length;
        var max2 = -Infinity;
        var i;
        for (i = 0; l > i; i++) {

            if (datamax2[i] > max2) {

                max2 = datamax2[i];

            }

        }

        var max3;
        if (max1 > max2) {
            max3 = max1
        }
        else {
            max3 = max2
        }



        let h = height;
        let w = width;

        //var formatValue = d3.format(".0%");

        const svg = d3.select('#' + this.ID).append('svg')
            .attr("id", 'multichart' + this.ID)
            .attr('width', width + margin.left + margin.right)
            .attr('height', height + margin.top + margin.bottom)
            .style("background", "rgb(255, 255, 255");



        const yScale = d3.scaleLinear()
            .range([height, 0])
            .domain([0, max3 + 10]);


        const xScale = d3.scaleBand()
            .range([0, width])
            .domain(data.map((d) => d.catagory))
            .padding(0.3)

        const xScale1 = d3.scaleBand()
            .domain(['Value', 'Value2'])
            .range([0, xScale.bandwidth() + 5])

        const chart = svg.append('g')
            .attr('transform', `translate(${margin.left}, ${margin.top})`);

        var makeYLines = () => d3.axisLeft(yScale);
        chart.append('g')      
            .attr('class', 'grid')
            .call(makeYLines().ticks(5).tickSize(-width).tickFormat((d) => ""));
        chart.append('g')
            .call(d3.axisLeft(yScale).ticks(5))
        //.tickFormat((d) => d + "%"));

        chart.append('g')
            .attr('transform', `translate(0, ${height})`)
            .call(d3.axisBottom(xScale))
            .selectAll("text")
            .style("text-anchor", "end")
            .attr("dx", "1em")
            .attr("dy", ".75em")
        //.attr("transform", (d) => "rotate(-65)");


        const barGroups = chart.selectAll()
            .data(data)
            .enter()
            .append('g')
            .attr("transform", d => `translate(${xScale(d.catagory)},0)`);

        barGroups.selectAll(".bar.Value")
            .data(d => [d])
            .enter()
            .append("rect")
            //.attr("class", "bar field1")
            .style("fill", "#376092")
            .attr("x", d => xScale1('Value'))
            .attr("y", d => yScale(d.Value))
            .attr("width", xScale1.bandwidth())
            .attr('height', (s) => height - yScale(s.Value))



        barGroups.selectAll(".bar.Value2")
            .data(d => [d])
            .enter()
            .append("rect")
            //.attr("class", "bar field1")
            .style("fill", "#93cddd")
            .attr("x", d => xScale1('Value2'))
            .attr("y", d => yScale(d.Value2))
            .attr("width", xScale1.bandwidth())
            .attr('height', (s) => height - yScale(s.Value2))
            .append('text')

        barGroups.append('text')
            //.attr('class', 'Value')
            .attr('x', (d) => xScale.bandwidth() / 3.5)
            .attr('y', (d) => yScale(d.Value) - 20)
            .attr('text-anchor', 'middle')
            .attr("fill", "#376092")
            .attr("font-size", "12")
            .text((d) => `${d.Value}`)
            .text((d) => d.Value > 0 ? d.Value : '')

        barGroups.append('text')
            //.attr('class', 'Value2')
            .attr('x', (d) => xScale1.bandwidth() * 1.5)
            .attr('y', (d) => yScale(d.Value2) - 20)
            .attr('text-anchor', 'middle')
            .attr("fill", "#93cddd")
            .attr("font-size", "12")
            .text((d) => `${d.Value2}`)
            .text((d) => d.Value2 > 0 ? d.Value2 : '')


        svg.append('text')
            .attr('class','chartname')
            .attr('x', width / 2)
            .attr('y', 12)
        .style("font-size", "16px")
        .style("font-weight", 'bold')
        .style('text-anchor', 'middle')
            .text(this.chartname)


        let nodeWidth = (d) => d.getBBox().width;
        //const cScale = d3.scaleOrdinal(d3.sche);

        const legend = svg.append('g')
            .attr('class', 'legend')
            .attr('transform', 'translate(0,0)');

        const lg = legend.selectAll('g')
            .data(legendList)
            .enter()
            .append('g')
        //.attr('transform', (d, i) => `translate(${i * 100},${height + 15})`);

        lg.append('rect')
            .style('fill', d => d.color)
            .attr('x', 10)
            .attr('y', - this.yScalelegendValue1)
            .attr('width', 15)
            .attr('height', 15);

        lg.append('text')
            .style('font-family', 'Georgia')
            .style('font-size', '15px')
            .attr('x', 30)
            .attr('y', - this.yScalelegendValue2)
            .text(d => d.legend);

        let offset = 0;
        lg.attr('transform', function (d, i) {
            let x = offset;
            offset += nodeWidth(this) + 10;
            return `translate(${x},${h + 10})`;
        });

        legend.attr('transform', function (d, i) {
            return `translate(${(w - nodeWidth(this)) / 2},${0})`
        });

    }


}


export interface ChartData {
    Values: Array<valueModel>;
    Legend: Array<legendModel>
}


export interface valueModel {
    catagory: string;
    Value: number;
    Value2: number;
    Value3: number;


}

export interface legendModel {
    legend: string;
    color: string;

}
