import { Component, OnInit, OnChanges, ElementRef, Input, ViewChild, ViewEncapsulation, SimpleChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import * as d3 from 'd3';
import { keys } from 'd3';
//import { stack } from 'd3';

@Component({
  selector: 'payment-multiple',
  templateUrl: './payment-multiple.component.html',
  styleUrls: ['./payment-multiple.component.css']
})
export class PaymentMultipleComponent implements OnInit, OnChanges {

  constructor(
    private http: HttpService
  ) { }

  @Input() serviceName1: string;
  @Input() OutletID1: string;
  @Input() FY1: string;
  //@Input() headerCSI: string; 
  @Input() ID1: string;
  @Input("ID") ID2: string;
  @Input("chartname") chartname1: string;
  @Input() Showtable: boolean = true;
  @Input() xScaleSizeChartPayment: any;
  @Input() yScaleSizeChartPayment: any;
  @Input() xScaleSizeBarPayment: any;
  @Input() yScaleSizeBarPayment: any;
  @Input() xScaleSizeBarMultiple: any;
  @Input() yScaleSizeBarMultiple: any;
  @Input() DATA_MONTH: any;
  @Input() QTR1: string;
  @ViewChild('chart', { static: true }) chartContainer: ElementRef;

  @Input("ID") ID: string;

  @Input() yAxisMax: number;
  @Input() xAxisMax: number;
  @Input() yScalelegendValue1: any;
  @Input() yScalelegendValue2: any;
  @Input() labelQTR: any;

  @Input() qRefresh: string;

  public data1Total: any = {};
  private dataSSI: any = [];
  private dataCSI: any = [];
  private dataAll: any = [];
  private dataSSI_BP: any = [];
  private dataCSI_BP: any = [];
  private dataAll_BP: any = [];

  public dataVDM: any = [];
  private svg2: any;
  private svg3: any;

  private yScale2: any;
  private yScale3: any;
  private xScale: any;
  private xAxis: any;

  private yAxis2: any;
  private yAxis3: any;

  private chart2: any;
  private chart3: any;

  private barGroups2: any;
  private barGroups3: any;
  private data: any
  public dataListTabel: any;
  private YearList: any;

  public chartColor: string;
  public chartColor3: string;
  public _this: any;
  public chartTitle: string;

  public cCurrency: string;
  public legendSSI: any = [];
  public legendCSI: any = [];
  public legendAll: any = [];
  public serviceSSI: string;
  public serviceCSI: string;


  private labelxScalemonth12 = ["Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "Jan", "Feb", "Mar"];


  ngOnInit() {

    if (this.OutletID1 != '') {
      this.cCurrency = 'kTHB';
    } else {
      this.cCurrency = 'mTHB';
    }
    this.chartColor = '#80cbc4'; //'#ffb034';
    this.chartColor3 = '#93cddd';
    this.chartTitle = 'SSI payment';


    this.legendSSI = [{ legend: "SSI", color: this.chartColor }, { legend: "SSI BP", color: '#c00000' }]
    this.legendCSI = [{ legend: "CSI", color: this.chartColor3 }, { legend: "CSI BP", color: '#c00000' }]
    this.legendAll = [{ legend: "SSI & CSI", color: '#376092' }, { legend: "SSI & CSI BP", color: '#c00000' }]
    //this.dataLegend = [{

    //  Legend: [{ legend: 'SSI', color: '#376092' },
    //  { legend: 'CSI', color: '#93cddd' }]
    //}]

    if (this.yScalelegendValue1 == 0) {
      this.yScalelegendValue1 = -258
    }
    if (this.yScalelegendValue2 == 0) {
      this.yScalelegendValue1 = -245
    }

   

  }

  ngOnChanges(changes: SimpleChanges): void {

    if (!changes["qRefresh"].isFirstChange()) {
      d3.select("#" + 'pay1_ssi').remove();
      d3.select("#" + 'pay1_csi').remove();
      this.SetupChart();
      //this.GetData();
      this.data1Total = {};
      this.data1Total.SSI_PAYMENT = 0;
      this.data1Total.CSI_PAYMENT = 0;

      this.data1Total.RS_UNIT = 0;
      this.data1Total.FLEET_UNIT = 0;
      this.data1Total.DEMO_CAR = 0;
      this.data1Total.ALL_UNIT = 0;
      this.data1Total.CONFIRM_UNIT = 0;
      this.data1Total.RO_UNIT = 0;
      this.data1Total.NOT_CONFIRM_UNIT = 0;
      this.data1Total.REMAIN_UNIT = 0;
    }

  }

  ngAfterViewInit() {
    this.SetupChart();
    // this.GetData2(this.ID2)
   // this.GetData();
  }

  AfterContentInit() {

  }

  GenerateHearder(text) {
    let month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
    let newtext = text.substring(4)
    return month[Number(newtext) - 1]

  }

  GetData() {

    if (this.QTR1 == '0' && this.DATA_MONTH == '') { //----- FY


      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_FY', this.FY1)
        .subscribe(result => {
          this.dataSSI = result.Table;
          this.dataCSI = result.Table1;
          this.dataAll = result.Table2;
          this.dataListTabel = result.Table3
          this.CreateChart2(this.dataSSI);
          this.CreateChart3(this.dataCSI);
        })

      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_BP', this.FY1)
        .subscribe(result => {
          this.dataSSI_BP = result.Table;
          this.dataCSI_BP = result.Table1;
          this.dataAll_BP = result.Table2;

        })

      this.http.get('System', 'GetVDMPerformance', this.FY1)
        .subscribe(result => {
          this.dataVDM = result.Table;
          this.SummaryDataList();
        })
    } else if (this.QTR1 != '0') { //----- Quarter
      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_FY', this.FY1)
        .subscribe(result => {
          this.dataSSI = result.Table;
          this.dataCSI = result.Table1;
          this.dataAll = result.Table2;
          this.dataListTabel = result.Table3
          this.CreateChart2(this.dataSSI);
          this.CreateChart3(this.dataCSI);
        })

      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_BP', this.FY1)
        .subscribe(result => {
          this.dataSSI_BP = result.Table;
          this.dataCSI_BP = result.Table1;
          this.dataAll_BP = result.Table2;

        })

      this.http.get('System', 'GetVDMPerformanceQT', this.FY1, this.QTR1)
        .subscribe(result => {
          this.dataVDM = result.Table;
          this.SummaryDataList();
        })

    } else if (this.QTR1 == '0' && this.DATA_MONTH != '') { //----- Monthly

      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_FY', this.FY1)
        .subscribe(result => {
          this.dataSSI = result.Table;
          this.dataCSI = result.Table1;
          this.dataAll = result.Table2;
          this.dataListTabel = result.Table3
          this.CreateChart2(this.dataSSI);
          this.CreateChart3(this.dataCSI);
        })

      this.http.get("System", 'Get_DSB_Payment_SSI_CSI_BP', this.FY1)
        .subscribe(result => {
          this.dataSSI_BP = result.Table;
          this.dataCSI_BP = result.Table1;
          this.dataAll_BP = result.Table2;

        })

      this.http.get('System', 'GetVDMPerformanceMonthly', this.DATA_MONTH)
        .subscribe(result => {
          this.dataVDM = result.Table;

          this.SummaryDataList();
        })
    }

    if (this.OutletID1 != '') {
      this.http.get("System", this.serviceName1, this.FY1, this.OutletID1)
        .subscribe(result => {
          this.dataSSI = result.Table;
          this.dataCSI = result.Table1;
          this.dataAll = result.Table2;
          this.dataListTabel = result.Table3
          this.CreateChart2(this.dataSSI);
          this.CreateChart3(this.dataCSI);
        })

    }

  }

  private SummaryDataList() {
    this.data1Total = {};
    this.data1Total.SSI_PAYMENT = 0;
    this.data1Total.CSI_PAYMENT = 0;
    this.data1Total.BP_SSI_PAYMENT = 0;
    this.data1Total.BP_CSI_PAYMENT = 0;

    this.data1Total.RS_UNIT = 0;
    this.data1Total.FLEET_UNIT = 0;
    this.data1Total.DEMO_CAR = 0;
    this.data1Total.ALL_UNIT = 0;
    this.data1Total.CONFIRM_UNIT = 0;
    this.data1Total.RO_UNIT = 0;
    this.data1Total.NOT_CONFIRM_UNIT = 0;
    this.data1Total.REMAIN_UNIT = 0;

    this.dataVDM.forEach((value) => {
      //console.log(value.RS_UNIT);
      this.data1Total.SSI_PAYMENT = this.data1Total.SSI_PAYMENT + value.SSI_PAYMENT;
      this.data1Total.CSI_PAYMENT = this.data1Total.CSI_PAYMENT + value.CSI_PAYMENT;
      this.data1Total.BP_SSI_PAYMENT = this.data1Total.BP_SSI_PAYMENT + value.BP_SSI_PAYMENT;
      this.data1Total.BP_CSI_PAYMENT = this.data1Total.BP_CSI_PAYMENT + value.BP_CSI_PAYMENT;

      this.data1Total.RS_UNIT = this.data1Total.RS_UNIT + value.RS_UNIT;
      this.data1Total.FLEET_UNIT = this.data1Total.FLEET_UNIT + value.FLEET_UNIT;
      this.data1Total.DEMO_CAR = this.data1Total.DEMO_CAR + value.DEMO_CAR;
      this.data1Total.ALL_UNIT = this.data1Total.ALL_UNIT + value.ALL_UNIT;
      this.data1Total.CONFIRM_UNIT = this.data1Total.CONFIRM_UNIT + value.CONFIRM_UNIT;

      this.data1Total.RO_UNIT = this.data1Total.RO_UNIT + value.RO_UNIT;

    });

    this.data1Total.SSI_PAYMENT = this.data1Total.SSI_PAYMENT / 1000000;
    this.data1Total.CSI_PAYMENT = this.data1Total.CSI_PAYMENT / 1000000;
    this.data1Total.BP_SSI_PAYMENT = this.data1Total.BP_SSI_PAYMENT / 1000000;
    this.data1Total.BP_CSI_PAYMENT = this.data1Total.BP_CSI_PAYMENT / 1000000;
  }

  SetupChart() {



    width = this.xScaleSizeChartPayment;
    if (width == null) {
      width = 800 - margin.left - margin.right
    }
    height = this.yScaleSizeChartPayment
    if (height == null) {
      height = 350 - margin.top - margin.bottom
    }
    var margin = { top: 30, right: 20, bottom: 40, left: 40 },
      width = width - margin.left - margin.right,
      height = height - margin.top - margin.bottom;
  

    let data: valueModel[];

    data = [{ catagory: 'XXX', Value: 50 }, { catagory: 'ZZZ', Value: 90 }]

    this.svg2 = d3.select('#csi').append('svg')
      .attr("id", 'pay1_ssi')
      .attr('width', width + margin.left + margin.right)
      .attr('height', height + margin.top + margin.bottom)
      .style("background", "rgb(255, 255, 255");

    this.svg3 = d3.select('#csi').append('svg')
      .attr("id", 'pay1_csi')
      .attr('width', width + margin.left + margin.right)
      .attr('height', height + margin.top + margin.bottom)
      .style("background", "rgb(255, 255, 255");

    this.yScale2 = d3.scaleLinear()
      .range([height, 0])
    this.yScale3 = d3.scaleLinear()
      .range([height, 0])

    this.xScale = d3.scaleBand()
      .range([0, width])
      .paddingInner(0.35)
      .paddingOuter(0.1)

    this.xAxis = d3.axisBottom(this.xScale);
    this.yAxis2 = d3.axisLeft(this.yScale2).ticks(5)
    this.yAxis3 = d3.axisLeft(this.yScale3).ticks(5)

    this.chart2 = this.svg2.append('g')
      .attr('transform', `translate(${margin.left}, ${margin.top})`);

    this.chart2.append('g')
      .attr("class", "y axis2")
      .call(this.yAxis2);

    this.chart2.append('g')
      .attr("class", "xAxis")
      .attr('transform', `translate(0, ${height})`)
      .call(this.xAxis)
      .selectAll("text")
      .style("text-anchor", "end")

    this.chart3 = this.svg3.append('g')
      .attr('transform', `translate(${margin.left}, ${margin.top})`);

    this.chart3.append('g')
      .attr("class", "y axis3")
      .call(this.yAxis3);

    this.chart3.append('g')
      .attr("class", "xAxis")
      .attr('transform', `translate(0, ${height})`)
      .call(this.xAxis)
      .selectAll("text")
      .style("text-anchor", "end")

    this.GetData()

  }

  private CreateChart2(gData) {

    width = this.xScaleSizeBarPayment
    if (width == null) {
      width = 550 - margin.left - margin.right
    }

    height = this.yScaleSizeBarPayment
    if (height == null) {
      height = 350 - margin.top - margin.bottom;
    }

    var margin = { top: 30, right: 20, bottom: 40, left: 40 },
      width = width - margin.left - margin.right,
      height = height - margin.top - margin.bottom;


    let data: valueModel[];
    data = gData


    var yMinDomain = this.GenerateYminDomain(data)
    var yMaxDomain = this.GenerateYmaxDomain(data)


    this.yScale2.domain([yMinDomain, yMaxDomain])
    this.xScale.domain(this.labelxScalemonth12.map(d => d))

    this.chart2
      .select(".y")
      .call(this.yAxis2);

    this.chart2
      .select(".xAxis")
      .attr('transform', `translate(0, ${height})`)
      .call(this.xAxis)
      .selectAll("text")


    //create range of grid line from yScale
    this.svg2.select('.grid').remove();//remove then create new because each data had scale of it.
    var makeYLines = () => d3.axisLeft(this.yScale2);
    this.chart2.append('g')
      .attr('class', 'grid')
      .call(makeYLines().ticks(5).tickSize(-width).tickFormat((d) => ""));

    let xScaleOfBar = this.xScale;
    let yScaleOfBar = this.yScale2;

    let chart = this.chart2;
    this.barGroups2 = this.chart2.selectAll(".bar2")

      .data(data)

    this.barGroups2
      .enter()
      .append("rect")
      .merge(this.barGroups2)
      .attr("class", "bar2")
      //.transition().duration(100)
      .attr('x', (d) => this.xScale(d.catagory))
      .attr('y', (d) => this.yScale2(d.Value > 0 ? d.Value : 0))
      .attr('height', (s) => height - this.yScale2(s.Value))
      .attr('width', this.xScale.bandwidth())

      .attr("fill",
        (d) => {

          if (this.QTR1 == '1') {
            if (d.DATA_MONTH.substring(4) == '04' || d.DATA_MONTH.substring(4) == '05' || d.DATA_MONTH.substring(4) == '06') {
              return this.chartColor;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '2') {
            if (d.DATA_MONTH.substring(4) == '07' || d.DATA_MONTH.substring(4) == '08' || d.DATA_MONTH.substring(4) == '09') {
              return this.chartColor;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '3') {
            if (d.DATA_MONTH.substring(4) == '10' || d.DATA_MONTH.substring(4) == '11' || d.DATA_MONTH.substring(4) == '12') {
              return this.chartColor;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '4') {
            if (d.DATA_MONTH.substring(4) == '01' || d.DATA_MONTH.substring(4) == '02' || d.DATA_MONTH.substring(4) == '03') {
              return this.chartColor;
            } else {
              return '#ddd';
            }

          } else if (this.DATA_MONTH != '') {
            if (d.DATA_MONTH == this.DATA_MONTH) {
              return this.chartColor;
            } else {
              return '#ddd';
            }
          } else {
            return this.chartColor;
          }


        }).on('mouseenter', function (actual, i) {

          d3.selectAll('.value')
            .attr('opacity', 0)

          d3.select(this)
            .transition()
            .duration(300)
            .attr('opacity', 0.6)
            .attr('x', (d) => xScaleOfBar(actual.catagory) - 5)
            .attr('width', xScaleOfBar.bandwidth() + 10)

          var y = yScaleOfBar(actual.Value);

          var line = chart.append('rect')
            .transition()
            .duration(500)
            .attr('id', 'showzone')
            .attr('x', 0)
            .attr('y', 0)
            .attr('width', width)
            .attr('height', y)
            .attr("fill", "blue")
            .attr('opacity', 0.1)

        })
      .on('mouseleave', function (actual) {
        d3.selectAll('.value')
          .attr('opacity', 1)

        d3.select(this)
          .transition()
          .duration(300)
          .attr('opacity', 1)
          .attr('x', (a) => xScaleOfBar(actual.catagory))
          .attr('width', xScaleOfBar.bandwidth())

        chart.selectAll('#showzone').remove()

      });

    this.barGroups2 = this.chart2.selectAll(".textvalue2")
      .remove()
      .exit()
      .data(data)

    this.barGroups2
      .enter()
      .append('text')
      .attr('class', 'textvalue2')
      .attr('x', (d) => this.xScale(d.catagory) + this.xScale.bandwidth() / 2)
      .attr('y', (d) => this.yScale2(d.Value) - 15)
      .attr('text-anchor', 'middle')
      .attr("fill", "#000000")
      .attr("font-size", "13.5")
      .text((d) => d.Value > 0 ? d.Value : '')


    this.svg2.select('.textH').remove()

    this.chart2.append('text')
      .attr('class', 'textH')
      .attr('x', width / 2)
      .attr('y', -12)
      .style("font-size", "16")
      .attr('text-anchor', 'middle')
      .style("font-weight", 'bold')
      .style("fill", "black")
      .text('SSI Payment(' + this.cCurrency + ')')


  }

  private CreateChart3(gData) {

    width = this.xScaleSizeBarPayment
    if (width == null) {
      width = 550 - margin.left - margin.right
    }

    height = this.yScaleSizeBarPayment
    if (height == null) {
      height = 350 - margin.top - margin.bottom;
    }

    var margin = { top: 30, right: 20, bottom: 40, left: 40 },
      width = width - margin.left - margin.right,
      height = height - margin.top - margin.bottom;

    let data: valueModel[];

    data = gData;

    var yMinDomain = this.GenerateYminDomain(data)
    var yMaxDomain = this.GenerateYmaxDomain(data)

    this.yScale3.domain([yMinDomain, yMaxDomain + 2])
    this.xScale.domain(this.labelxScalemonth12.map(d => d))

    this.labelQTR = this.xScale.domain

    this.chart3
      .select(".y")
      .call(this.yAxis3)

    this.chart3
      .select(".xAxis")
      .attr('transform', `translate(0, ${height})`)
      .call(this.xAxis)
      .selectAll("text")


    //create range of grid line from yScale
    this.svg3.select('.grid').remove();//remove then create new because each data had scale of it.
    var makeYLines = () => d3.axisLeft(this.yScale3);
    this.chart3.append('g')
      .attr('class', 'grid')
      .call(makeYLines().ticks(5).tickSize(-width).tickFormat((d) => ""));

    let xScaleOfBar = this.xScale;
    let yScaleOfBar = this.yScale3;

    let chart = this.chart3;

    this.barGroups3 = this.chart3.selectAll(".bar3")
      .data(data)

    this._this = this
    this.barGroups3
      .enter()
      .append("rect")
      .merge(this.barGroups3)
      .attr("class", "bar3")
      .attr('x', (d) => this.xScale(d.catagory))
      .attr('y', (d) => this.yScale3(d.Value > 0 ? d.Value : 0))
      .attr('height', (s) => height - this.yScale3(s.Value))
      .attr('width', this.xScale.bandwidth())

      .attr("fill",
        (d) => {

          if (this.QTR1 == '1') {
            if (d.DATA_MONTH.substring(4) == '04' || d.DATA_MONTH.substring(4) == '05' || d.DATA_MONTH.substring(4) == '06') {
              return this.chartColor3;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '2') {
            if (d.DATA_MONTH.substring(4) == '07' || d.DATA_MONTH.substring(4) == '08' || d.DATA_MONTH.substring(4) == '09') {
              return this.chartColor3;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '3') {
            if (d.DATA_MONTH.substring(4) == '10' || d.DATA_MONTH.substring(4) == '11' || d.DATA_MONTH.substring(4) == '12') {
              return this.chartColor3;
            } else {
              return '#ddd';
            }

          } else if (this.QTR1 == '4') {
            if (d.DATA_MONTH.substring(4) == '01' || d.DATA_MONTH.substring(4) == '02' || d.DATA_MONTH.substring(4) == '03') {
              return this.chartColor3;
            } else {
              return '#ddd';
            }

          } else if (this.DATA_MONTH != '') {
            if (d.DATA_MONTH == this.DATA_MONTH) {
              return this.chartColor3;
            } else {
              return '#ddd';
            }
          } else {
            return this.chartColor3;
          }

        }).on('mouseenter', function (actual, i) {
          d3.selectAll('.value')
            .attr('opacity', 0)

          d3.select(this)
            .transition()
            .duration(300)
            .attr('opacity', 0.6)
            .attr('x', (d) => xScaleOfBar(actual.catagory) - 5)
            .attr('width', xScaleOfBar.bandwidth() + 10)

          var y = yScaleOfBar(actual.Value);

          var line = chart.append('rect')
            .transition()
            .duration(500)
            .attr('id', 'showzone')
            .attr('x', 0)
            .attr('y', 0)
            .attr('width', width)
            .attr('height', y)
            .attr("fill", "blue")
            .attr('opacity', 0.1)
            ;

        })
      .on('mouseleave', function (actual) {
        d3.selectAll('.value')
          .attr('opacity', 1)

        d3.select(this)
          .transition()
          .duration(300)
          .attr('opacity', 1)
          .attr('x', (a) => xScaleOfBar(actual.catagory))
          .attr('width', xScaleOfBar.bandwidth())

        chart.selectAll('#showzone').remove()

      });

    this.barGroups3 = this.chart3.selectAll(".textvalue")
      .remove()
      .exit()
      .data(data)

    this.barGroups3
      .enter()
      .append('text')
      .attr('class', 'textvalue')
      .attr('x', (d) => this.xScale(d.catagory) + this.xScale.bandwidth() / 2)
      .attr('y', (d) => this.yScale3(d.Value) - 15)
      .attr('text-anchor', 'middle')
      .style("font-size", "12")
      .attr("fill", '#376092')
      .text((d) => d.Value > 0 ? d.Value : '')

    this.svg3.select('.textH').remove()

    this.chart3.append('text')
      .attr('class', 'textH')
      .attr('x', width / 2)
      .attr('y', -12)
      .style("font-size", "16")
      .attr('text-anchor', 'middle')
      .style("font-weight", 'bold')
      .style("fill", "black")
      .text('CSI Payment (' + this.cCurrency + ')')

  }

  GenerateHearderList(data) {
    let newData = [];
    for (var key in data[0]) {
      if (key != 'FY' && key != 'catagory') {
        newData.push(key)
      }

    }
    return newData
  }

  GenerateYmaxDomain(data: valueModel[]) {
    var yMaxDomain: number;
    yMaxDomain = d3.max(data, d => Number(d.Value))
    yMaxDomain = yMaxDomain + ((yMaxDomain * 10) / 100);

    return yMaxDomain
  }

  GenerateYminDomain(data: valueModel[]) {
    var yMinDomain: number = 0;
    return yMinDomain
  }

  FYChange() {
    this.GetData()
  }


  public Select_data(selectItem) {
    this.chartTitle = selectItem;
    console.log('this.chartTitle : ' + this.chartTitle);
    if (selectItem == 'SSI payment') {
      //this.chartColor = '#80cbc4';\ this.CreateChart3(this.dataSSI);
      //this.SetupChart();
      //this.CreateChart2(this.dataSSI);
      //this.CreateChart3(this.dataCSI);

    } else if (selectItem == 'CSI payment') {
      //this.chartColor = '#93cddd';
      //this.SetupChart();
     // this.CreateChart2(this.dataSSI);
     // this.CreateChart3(this.dataCSI);

    } else if (selectItem == 'Total payment') {
      //this.chartColor = '#376092';
     // this.SetupChart();
      //this.CreateChart2(this.dataSSI);
      //this.CreateChart3(this.dataCSI);

    } else if (selectItem == 'SSI Body & Paint') {
      this.chartColor = '#f56f6f';
      // this.CreateChart3(this.dataSSI);
      //alert('This is example data');
    } else if (selectItem == 'CSI Body & Paint') {
      // this.chartColor = '#ee9b4b';
      //this.CreateChart3(this.dataCSI);
      // alert('This is example data');
    } else if (selectItem == 'Total Body & Paint') {
      //this.chartColor = '#ed2929';
      //this.CreateChart3(this.dataAll);
      //alert('This is example data');
    }

  }
}


export interface ChartData {
  Values: Array<valueModel>;
  Legend: Array<legendModel>
}


export interface valueModel {
  catagory: string;
  Value: number;
  //Value2: number;
  //Value3: number;
}

export interface legendModel {
  legend: string;
  color: string;

}



