import { Component, OnInit, OnChanges, ElementRef, Input, ViewChild, ViewEncapsulation } from '@angular/core';
import * as d3 from 'd3';

@Component({
  selector: 'pie-chart',
  templateUrl: './pie-chart.component.html',
  styleUrls: ['./pie-chart.component.css']
})

export class PieChartComponent implements OnInit, OnChanges {
  constructor() { }

  @Input("data") data: ChartData[];
  @ViewChild('chart', { static: true }) chartContainer: ElementRef;
  //private chartContainer: ElementRef;

  //margin = { top: 20, right: 20, bottom: 30, left: 40 };

  ngOnInit() {
    //if (!this.data) { return; }
    this.createChart();    
  }

  ngOnChanges(): void {
  }

  ngAfterViewInit() {

  }

  //detail: test[];
  _current: any;
  public createChart() {

    var data = [
      { label: "Pass", value: 98, color: "#3a5bc5" }, 
      { label: "Fail", value: 30, color: "#d6bb21" }
    ];
    var data2 = [
      { label: "Pass", value: 99, color: "#8fcd4e" },
      { label: "Fail", value: 70, color: "#d6bb21" }
    ];
    var data3 = [
      { label: "Pass", value: 98, color: "#3a5bc5" }, 
      { label: "Fail", value: 50, color: "#d6bb21" }
    ];
    var data4 = [
      { label: "Pass", value: 20, color: "#8fcd4e" },
      { label: "Fail", value: 80, color: "#d6bb21" }
    ];

    var svg = d3.select("#group-pie").append("svg").attr("width", 1000).attr("height", 300);
    
    svg.append("g")
      .attr("id", "pie-chart")
      .append("text")
      .attr('x', 75)
      .attr('y', 30)
      .text("1-3 Qualifiers")
      .attr("class", "title");


    svg.append("g")
      .attr("id", "pie-chart2")    
      .append("text")
      .attr('x', 350)
      .attr('y', 30)
      .text("1 Self-Assessment")
      .attr("class", "title");


    svg.append("g")
      .attr("id", "pie-chart3")     
      .append("text")
      .attr('x', 680)
      .attr('y', 30)
      .text("2 Quick VOC")
      .attr("class", "title");

    svg.append("g")
      .attr("id", "pie-chart4")     
      .append("text")
      .attr('x', 980)
      .attr('y', 30)
      .text("3 Manpower")
      .attr("class", "title");

    this.generateChart('pie-chart', data, 150, 150, 130, 100, 30, 0)
    this.generateChart('pie-chart2', data2, 450, 150, 130, 100, 30, 0)
    this.generateChart('pie-chart3', data3, 750, 150, 130, 100, 30, 0)
    this.generateChart('pie-chart4', data4, 1050, 150, 130, 100, 30, 0)

    
  }


  generateChart(id,data,x,y,rx,ry,hi,ir) {

    var _data = d3.pie<Datum>().value(function (d) { return d.value; })(data);
    

    //select #'pie-chart' from svg and add class = "slices" to it.
    var slices = d3.select("#" + id).append("g").attr("transform", "translate(" + x + "," + y + ")")
      .attr("class", "slices");

    //ชิ้นในวงรี
    //select class 'innerSlice' append "path" for fill color to it.
    /*
    slices.selectAll(".innerSlice").data(_data).enter().append("path").attr("class", "innerSlice")
      .style("fill", function (d) { return d3.hsl(d.data.color).darker(0.7).toString(); })
      .attr("d", function (d) { return pieInner(d, rx + 0.5, ry + 0.5, hi, ir); })
      .each(function (d) { d; });
    */
      

    //วงรีชิ้นบน
    //select class 'topSlice' append "path" for fill color and stroke to it.
    slices.selectAll(".topSlice").data(_data).enter().append("path").attr("class", "topSlice")
      .style("fill", function (d) { return d.data.color; })
      .attr("d", function (d) { return pieTop(d, rx, ry, ir); })
      .each(function (d) { d; }).on('mouseenter', function (actual, i) {
        d3.select(this)
          .transition()
          .duration(400)
          //.attr('opacity', 0.7)
          .style("fill", (d: any) => { return d3.hsl(d.data.color).darker(0.9).toString(); })
          
          slices.selectAll('.outerSlice')
          .attr('opacity', 0.2)

          

      })
      .on('mouseleave', function () {
        d3.selectAll('.value')
          .attr('opacity', 1)

        d3.select(this)
          .transition()
          .duration(100)
          //.attr('opacity', 1)
          .style("fill", (d: any) => { return d3.hsl(d.data.color).toString(); })

          slices.selectAll('.outerSlice')
          .attr('opacity', 1)
      });

    //วงรีซิ้วพระจันทร์
    //select class 'outerSlice' append "path" for fill color ro it.    
    slices.selectAll(".outerSlice").data(_data).enter().append("path").attr("class", "outerSlice")
      .style("fill", function (d) { return d3.hsl(d.data.color).darker(0.7).toString(); })
      .attr("d", function (d) { return pieOuter(d, rx - .5, ry - .5, hi); })
      //.each(function (d) { d; });
    

    //append "text" is percent in pie    
    slices.selectAll(".percent").data(_data).enter().append("text").attr("class", "percent")
      .attr("x", function (d) { return 0.6 * rx * Math.cos(0.5 * (d.startAngle + d.endAngle)); })
      .attr("y", function (d) { return 0.6 * ry * Math.sin(0.5 * (d.startAngle + d.endAngle)); })
      .text(getPercent).each(function (d) { d; });
    

    function pieInner(d, rx, ry, h, ir) {
      var startAngle = (d.startAngle < Math.PI ? Math.PI : d.startAngle);
      var endAngle = (d.endAngle < Math.PI ? Math.PI : d.endAngle);

      var sx = ir * rx * Math.cos(startAngle),
        sy = ir * ry * Math.sin(startAngle),
        ex = ir * rx * Math.cos(endAngle),
        ey = ir * ry * Math.sin(endAngle);

      var ret = [];
      ret.push("M", sx, sy, "A", ir * rx, ir * ry, "0 0 1", ex, ey, "L", ex, h + ey, "A", ir * rx, ir * ry, "0 0 0", sx, h + sy, "z");
      return ret.join(" ");
    }

    function pieTop(d, rx, ry, ir) {
      if (d.endAngle - d.startAngle == 0) return "M 0 0";
      var sx = rx * Math.cos(d.startAngle),
        sy = ry * Math.sin(d.startAngle),
        ex = rx * Math.cos(d.endAngle),
        ey = ry * Math.sin(d.endAngle);

      var ret = [];
      ret.push("M", sx, sy, "A", rx, ry, "0", (d.endAngle - d.startAngle > Math.PI ? 1 : 0), "1", ex, ey, "L", ir * ex, ir * ey);
      ret.push("A", ir * rx, ir * ry, "0", (d.endAngle - d.startAngle > Math.PI ? 1 : 0), "0", ir * sx, ir * sy, "z");
      return ret.join(" ");
    }

    function pieOuter(d, rx, ry, h) {
      var startAngle = (d.startAngle > Math.PI ? Math.PI : d.startAngle);
      var endAngle = (d.endAngle > Math.PI ? Math.PI : d.endAngle);

      var sx = rx * Math.cos(startAngle),
        sy = ry * Math.sin(startAngle),
        ex = rx * Math.cos(endAngle),
        ey = ry * Math.sin(endAngle);

      var ret = [];
      ret.push("M", sx, h + sy, "A", rx, ry, "0 0 1", ex, h + ey, "L", ex, ey, "A", rx, ry, "0 0 0", sx, sy, "z");
      return ret.join(" ");
    }

    function getPercent(d) {
      return (d.endAngle - d.startAngle > 0.2 ?
        Math.round(1000 * (d.endAngle - d.startAngle) / (Math.PI * 2)) / 10 + '%' : '');
    }	


  }
}


export interface ChartData {
  Values: Array<valueModel>;
  Legend: Array<legendModel>
}


export interface valueModel {
  catagory: string;
  Value: number;
  Value2: number;
  Value3: number;
}

export interface legendModel {
  legend: string;
  color: string;
}


export interface Datum {
  label: string;
  value: number;
  color: string;
}
