import { Component, Inject } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { HttpService } from 'src/app/core/http.service';

//@NgModule.entryComponents

export interface DialogData {
    data_type: string;
    data_name: string;
    result: string; 
    finding_word: string;

}

@Component({
    selector: 'simple-dialog',
    templateUrl: './dialog-po.component.html',
    styleUrls: ['./dialog-po.component.css']
})


export class DialogPoComponent {

    constructor(
        public dialogRef: MatDialogRef<DialogPoComponent>,
        private http: HttpService,
        @Inject(MAT_DIALOG_DATA) public data: DialogData) {

        //this.dataList = [{ ITEM_NO: 'P001_01', ITEM_NAME: "PO 1" }
        //    , { ITEM_NO: 'P002_02', ITEM_NAME: "PO 2" }
        //    , { ITEM_NO: 'P003_03', ITEM_NAME: "PO 3" }]
    }


    public dataList: any = [];
    public findingWord: string;
    ngOnInit() {




    }

    public Find() {

        if (this.findingWord.length >= 3) {

            this.http.get("System", "FindPO", this.findingWord)
                .subscribe(result => {
                    console.log('this.result', result)
                    this.dataList = result.Table;

                })


        } else {
            alert('Please input at less 3 characters');
        }

    }

    onNoClick(): void {
        this.dialogRef.close();
    }
}
