import { Component, Inject, ContentChild, TemplateRef} from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

export interface DialogData {
  //template: string,
  //Detail: any,
  //Header: any,
  //Target: string,
  //ShowTable: boolean,
  //TypeData: string,
  //TypeChart: string,
  //showLine: boolean,
  //HeaderChart: string,
  //SERVICE_NAME : string
  config : any
}

@Component({
  selector: 'custom-dialog',
  templateUrl: 'dialog.component.html',
  styleUrls : ['dialog.component.css']
})
export class CustomDialogComponent {
     
     
  @ContentChild(TemplateRef, { static: false }) templateRef;

  constructor(
    public dialogRef: MatDialogRef<CustomDialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data : DialogData
    ) { }
    //@Inject(MAT_DIALOG_DATA) public data: DialogData) { }

  private isCustomContent: boolean = false;
  public sortType: any;
  public sortReverse: boolean = false;

  ngOnInit(): void {
    //console.log('data',this.data)

  }

  ngAfterContentInit(): void {
    if (this.templateRef) {
      this.isCustomContent = true;
    }
  }

  onNoClick(): void {
    this.dialogRef.close();
  }

  OrderColumn(pColName) {
    //console.log('pColName',pColName)
    this.sortType = pColName;
    this.sortReverse = !this.sortReverse;
  };

}
