import { Component, OnInit, Input, Output, EventEmitter, Directive, ViewChild, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';

@Component({
  selector: 'file-upload',
  templateUrl: './file-upload.component.html',
  styleUrls: ['./file-upload.component.css']
})



export class FileUploadComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private formBuilder: FormBuilder,
  ) { }

  //@ViewChild('fileUpload') myInputVariable: ElementRef;

  @Input() config: any;
  @Input() data: any;
  @Output() datacallback = new EventEmitter<string>();

  public states: any;
  public setting: any;
  myControl = new FormControl();
  filteredOptions: Observable<string[]>;
  private formData: any;
  uploadForm: FormGroup;
  fileInput: File;

  ngOnInit() {

   

    this.config = {

      uploadType : 'path'

    }

    //this.uploadForm = this.formBuilder.group({
    //  file: ['']
    //});

   
  }

  onFileSelect(fileInput) {
    this.fileInput = fileInput.target.files[0];
    console.log(this.fileInput)
  }

  //onFileSelect(event) {
  //  if (event.target.files.length > 0) {
  //    const file = event.target.files[0];
  //    this.uploadForm.get('file').setValue(file);

  //    console.log('this.uploadForm', this.uploadForm.value.file);
  //  }
  //}

  onSubmit() {
    const formData = new FormData();
    formData.append('file', this.fileInput);
    let datamonth = '201908';

    if (this.config.uploadType == 'path') {

      this.http.UploadFilePath(formData,datamonth).subscribe(result => {
       let data = result;
       
       formData.delete('file')     

      })

    }
    else {
     
      this.http.UploadFileData(formData, datamonth).subscribe(result => {
        let data = result;

        formData.delete('file')
      })
    }
  }

  Cancel() {

    this.fileInput = null;
  }


   generateFromData(files: Array<any>): FormData {
    let formData = new FormData();
    for (var i = 0; i < files.length; i++) {
      formData.append("file" + i.toString(), files[i].file, files[i].name);
      //formData.append(files[i].fileId, files[i].file, files[i].newFileName);
    }
    return formData;
  }

  




}
