import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';



@Component({
    selector: 'mega-menu',
    templateUrl: './mega-menu.component.html',
    styleUrls: ['./mega-menu.component.css']
})
export class MegaMenuComponent implements OnInit {
    public menus: Array<any> = [];
    @ViewChild("frame", { static: false }) frame: ElementRef;

    constructor(
        private router: Router,
        private global: Globals,
        private http: HttpService,


    ) { }

  private localPath: string = '/report-popup?'
    private FullPath: string;


    ngOnInit(): void {
        this.getSystemMenuList();
    }

    getSystemMenuList() {
        //this.http.get("System", "GetSystemMenu")
        //    .subscribe(result => {
        //        this.menus = result;
        //        // console.log('this.menus', this.menus)
        //    })
    }

    menuDetailFilter(headerId: number) {
        return this.menus.filter((v) => v.HEADER_ID === headerId);
    }

    menuHeaderFilter() {
        return this.menus.filter((v, i, s) => this.global.findUnique(v, i, s, "HEADER_ID"));
    }

    OpenReport(reportName, paraMeterType) {

        this.FullPath = origin + this.localPath + 'reportName=' + reportName + '&paraMeterType=' + paraMeterType;
        window.open(this.FullPath, '_blank');
    }

    Goto(url) {
        console.log(url);
        this.router.navigate([url]);
    }


}
