import { Component, Inject } from "@angular/core";
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
    templateUrl: './warn-modal.component.html',
    styleUrls: ['./modal.component.scss']
})
export class WarnModalComponent {

    public text: string;
    public buttons: any[];

    constructor(
        private dialogRef: MatDialogRef<WarnModalComponent>,
        @Inject(MAT_DIALOG_DATA) public dialogData: any
    ) { }
    
    ngOnDestroy () {
        setTimeout(() => {
          this.dialogRef ? this.dialogRef.close() : null;
        }, 100)
      }

    ngOnInit() {
        this.text = this.dialogData.text
        this.buttons = this.dialogData.actionButtons;
    }
}