import { Component, OnInit, Input, Sanitizer } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { CustomDialogComponent } from 'src/app/components/shared/dialog/dialog.component';
import { environment } from 'src/environments/environment';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';

@Component({
  selector: 'reportss',
  templateUrl: './reportss.component.html',
  styles: [`
        .report-container {
            width: 100vw;
          
            overflow: hidden;
        }

        iframe {
            width: 100%;
            height: 100%;
            border: none;
        }
    `]
})
export class ReportssComponent implements OnInit {

  @Input() reportName: string;
  @Input() showparameters: string;
  @Input() parameters: any;

  @Input() width: string;
  @Input() height: string;
  @Input() toolbar: string;

  public reportserver: string = environment.report.url
  private reportRootPath: string = environment.report.rootPath;

  private params: any;
  public reportUrl: SafeResourceUrl;

  public language: string='EN';

  constructor(
    private http: HttpService,
    private sanitizer: DomSanitizer,
  ) { }



  ngOnInit() {

    //this.reportserver = 'http://SMGO-NB02/ReportServer_SQL2012';

    //this.reportserver = 'http://10.192.33.209/ReportServer_QAVME';

    //reportUrl: string = 'DASH_Rep/Report/VME_Rpt_VDM_SSI_SOP';
    //this.showparameters = "true";
    this.parameters = {
      "FY": 19
      //"SampleStringParameter": null,
      //"SampleBooleanParameter": false,
      //"SampleDateTimeParameter": "9/1/2017",
      //"SampleIntParameter": 1,
      //"SampleFloatParameter": "123.1234",
      //"SampleMultipleStringParameter": ["Parameter1", "Parameter2"]
    };
    //this.language: string = "en-us";
    //width: number = 1000;
    //height: number = 800;
    //toolbar: string = "true";

    //this.reportUrl = environment.report.rootPath + '/Report/' + this.reportName;
   // this.language = "en-us";

    console.log('reportName height :' + this.reportName + ' : '+ this.height);

    this.params = this.buildParameterString();

    this.reportUrl = this.sanitizer.bypassSecurityTrustResourceUrl(
      this.reportserver.concat(
        "?",
        "/", this.reportRootPath, "/", this.reportName,
        "&rs:Embed=true",
        "&rc:Parameters=", this.showparameters,
        this.params,
        "&rs:ParameterLanguage=", this.language,
        "&rc:Toolbar=", this.toolbar
      )
    );
  }

  private buildParameterString(): string {

    var parameterString = "";

    for (var param in this.parameters) {
      if (param) {
        if (this.parameters[param] instanceof Array === true) {
          for (var arrayParam in this.parameters[param]) {
            if (arrayParam) {
              parameterString += "&" + param + "=" + this.parameters[param][arrayParam];
            }
          }
        }
        if (this.parameters[param] != null && this.parameters[param] instanceof Array === false) {
          parameterString += "&" + param + "=" + this.parameters[param];
        }
        if (this.parameters[param] == null) {
          parameterString += "&" + param + ":isnull=true";
        }
      }
    }
    return parameterString;
  }


}
