import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatToolbarModule } from '@angular/material/toolbar';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MatIconModule } from '@angular/material/icon';
import { CsmComponent } from '../../pages/csm/csm.component';
import { QuickVOCComponent } from '../../pages/csm/QuickVOC/QuickVOC.component';

 
 
@NgModule({
  declarations: [
    CsmComponent,
        QuickVOCComponent, 
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,
    MatSidenavModule,
    MatToolbarModule,
    MatIconModule,

    RouterModule.forChild([
      {
        path: '',
        component: CsmComponent,
        children: [
         
            {
                path: 'QuickVOC',
                component: QuickVOCComponent
            }

        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard],
})
export class CsmModule { }
