import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatToolbarModule } from '@angular/material/toolbar';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { DemoComponent } from 'src/app/pages/demo/demo.component';
import { MenuDemoComponent } from 'src/app/pages/demo/menu-demo/menu-demo.component';
import { MatIconModule } from '@angular/material/icon';


@NgModule({
  declarations: [
    DemoComponent,
    MenuDemoComponent,

  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,
    MatSidenavModule,
    MatToolbarModule,
    MatIconModule,

    RouterModule.forChild([
      {
        path: '',
        component: DemoComponent,
        children: [
          {
            path: 'MenuDemo',
            component: MenuDemoComponent,
          },
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard],
})
export class DemoModule { }
