import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatToolbarModule } from '@angular/material/toolbar';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MatIconModule } from '@angular/material/icon';
import { ReportComponent } from '../../pages/report/report.component';

 
 
@NgModule({
  declarations: [
    ReportComponent,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,
    MatSidenavModule,
    MatToolbarModule,
    MatIconModule,

    RouterModule.forChild([
      {
        path: '',
        children: [
          {
            path: ':exportTo/:reportName',
        component: ReportComponent,
            canActivate: [AuthGuard]
          },
            {
            path: ':reportName',
            component: ReportComponent,
            canActivate: [AuthGuard]
            }

        ]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class ReportModule { }
