import { TokenInterceptor } from 'src/app/core/token.interceptor';
import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HeaderComponent } from './../../components/shared/header/header.component';
import { HttpClientModule, HTTP_INTERCEPTORS } from '@angular/common/http';

import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatSortModule } from '@angular/material/sort';
import { MatTableModule } from '@angular/material/table';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatMenuModule } from '@angular/material/menu';
import { MatIconModule } from '@angular/material/icon';
import { MatSelectModule } from '@angular/material/select';
import { MatDialogModule } from '@angular/material/dialog';

import { BsDatepickerModule, BsDatepickerConfig } from 'ngx-bootstrap/datepicker';

import { HttpService } from './../../core/http.service';
import { Globals } from './../../core/global';
import { AutoTableComponent } from './../../components/shared/auto-table/auto-table.component';
import { MenuListComponent } from './../../components/shared/menu-list/menu-list.component';
import { AutoCompleteComponent, AutoCompleteDialog } from './../../components/shared/autoComplete/auto-complete.component';
import { DataMonthComponent } from './../../components/shared/dataMonth/data-month.component';
import { from } from 'rxjs';

import { setTheme } from 'ngx-bootstrap/utils';
import { FileUploadComponent } from './../../components/shared/file-upload/file-upload.component';
import { BarChartComponent } from './../../components/shared/chart/bar-chart/bar-chart.component';
import { MultipleBarChartComponent } from './../../components/shared/chart/multiple-bar-chart/multiple-bar-chart.component';
import { DualScaleComponent } from './../../components/shared/chart/dual-scale/dual-scale.component';
import { PieChartComponent } from './../../components/shared/chart/pie-chart/pie-chart.component';
import { BarWithLineComponent } from './../../components/shared/chart/bar-with-line/bar-with-line.component';
import { BarWithLineSingleComponent } from './../../components/shared/chart/bar-with-line-single/bar-with-line-single.component';
import { DoubleChartComponent } from './../../components/shared/chart/double-chart/double-chart.component';
import { barChartMonthOfYear } from './../../components/shared/chart/barChartMonthOfYear/barChartMonthOfYear.component';
import { MegaMenuComponent } from './../../components/shared/mega-menu/mega-menu.component';
import { MainMenuComponent } from './../../components/shared/main-menu/main-menu.component';
import { DealerMenuComponent } from './../../components/shared/dealer-menu/dealer-menu.component';

import { barWithDualLineComponent } from './../../components/shared/chart/barchart-with-dual-line/barchart-with-dual-line.component';

import { SsiCsiPaymentComponent } from './../../components/shared/chart/ssi-csi-payment/ssi-csi-payment.component';
import { DonutChartComponent } from './../../components/shared/chart/donut-chart/donut-chart.component';
import { MatButtonModule } from '@angular/material/button';
import { AuthDecode } from './../../core/auth-decode.service';
import { CustomDialogComponent } from './../../components/shared/dialog/dialog.component';
import { AutoCompleteQuerySearchComponent, AutoCompleteQuerySearchDialog } from './../../components/shared/auto-complete-query-search/auto-complete-query-search.component';

import { orderByPipe, FilterBytextPipe } from './../../pages/app.pipe';
import { GraphChartComponent } from '../../components/shared/chart/graph-chart/graph-chart.component';
import { GraphChartOneComponent } from '../../components/shared/chart/Graph/graph-chart-one/graph-chart-one.component';
import { GraphChartThreeComponent } from '../../components/shared/chart/Graph/graph-chart-three/graph-chart-three.component';
import { GraphChartTwoComponent } from '../../components/shared/chart/Graph/graph-chart-two/graph-chart-two.component';
import { LineChartComponent } from '../../components/shared/chart/line-chart/line-chart.component';
import { MaterialImportModule } from './material.module';
import { StackChartComponent } from '../../components/shared/chart/stack-chart/stack-chart.component';
import { PaymentComponent } from '../../components/shared/chart/payment/payment.component';
import { DualChartComponent } from '../../components/shared/chart/dual-chart/dual-chart.component';
import { CardComponent } from '../../components/shared/card/card.component';
import { ReportssComponent } from '../../components/shared/reportss/reportss.component';
//import { ReportViewerModule } from 'ngx-ssrs-reportviewer';
import { TableCardComponent } from '../../components/shared/Template/table-card/table-card.component';
import { LocalSurveySsiComponent } from '../../components/shared/Template/local-survey-ssi/local-survey-ssi.component';
import { MultipleBarChartManagementComponent } from '../../components/shared/chart/multiple-bar-chart-management/multiple-bar-chart-management.component';
import { MultipleBarChartManagementPercenComponent } from '../../components/shared/chart/multiple-bar-chart-management-percen/multiple-bar-chart-management-percen.component';
import { CircleComponent } from '../../components/shared/Template/circle/circle.component';
import { PaymentMultipleComponent } from '../../components/shared/chart/payment-multiple/payment-multiple.component';
import { CsmQualifyMonthlyComponent } from '../../components/shared/Template/csm-qualify-monthly/csm-qualify-monthly.component';
import { AutoCompleteQueryDialog, AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import { PieChartTwoComponent } from 'src/app/components/shared/chart/pie-chart-two/pie-chart-two.component';
import { DialogPoComponent } from 'src/app/components/shared/dialog-po/dialog-po.component';
import { SSIQualifiersResultComponent } from 'src/app/pages/csm/SSI-Qualifiers-Result/SSI-Qualifiers-Result.component';
import { ServiceCustomerDataQualityComponent } from 'src/app/pages/csm/Service-Customer-Data-Quality/Service-Customer-Data-Quality.component';
import { CSITargetAchievementComponent } from 'src/app/pages/csm/CSI-Target-Achievement/CSI-Target-Achievement.component';
import { StackBarChartComponent } from 'src/app/components/shared/chart/stack-bar-chart/stack-bar-chart.component';
import { NewStackBarChartComponent } from '../../components/shared/chart/new-stack-bar/new-stack-bar.component';
import { NewDualChartComponent } from 'src/app/components/shared/chart/new-dual-chart/new-dual-chart.component';
import { VdmAccruedComponent } from 'src/app/components/shared/Template/vdm-accrued/vdm-accrued.component';
import { DualChartWithLineComponent } from '../../components/shared/chart/dual-with-line/dual-with-line.component';
import { BarChart3DComponent } from '../../components/shared/chart/bar-chart-3d/bar-chart-3d.component';
import { DualChart3DComponent } from '../../components/shared/chart/dual-chart-3d/dual-chart-3d.component';
import { StackBarHorizontalComponent } from '../../components/shared/chart/stack-bar-horizontal/stack-bar-horizontal.component';
import { StackBarLineComponent } from '../../components/shared/chart/stack-bar-line/stack-bar-line.component';
import { BarChartLineValueComponent } from '../../components/shared/chart/bar-chart-line-value/bar-chart-line-value.component';
import { SimpleBarChartComponent } from '../../components/shared/chart/simple-bar-chart/simple-bar-chart.component';
import { GuageIComponent } from '../../components/shared/chart/guage-i-chart/guage-i-chart.component';
import { GuageIIComponent } from '../../components/shared/chart/guage-ii-chart/guage-ii-chart.component';
import { GuageIIIComponent } from '../../components/shared/chart/guage-iii-chart/guage-iii-chart.component';
import { BarMutiTargetComponent } from '../../components/shared/chart/bar-multi-target/bar-multi-target.component';
import { LineIChartComponent } from '../../components/shared/chart/line-i-chart/line-i-chart.component';
import { CustomerCommentComponent } from '../../components/shared/Template/qvoc-cus-comment/qvoc-cus-comment.component';
import { SystemMenuComponent } from '../../components/shared/system-menu/system-menu.component';
import { DialogTemplateCallerComponent, DialogTemplateCallerDialog } from '../../components/shared/dialog-template-caller/dialog-template-caller.component';
import { GuageIIIIChartComponent } from 'src/app/components/shared/chart/guage-iiii-chart/guage-iiii-chart.component';
import { SpeedMeterComponent } from 'src/app/components/shared/chart/speed-meter/speed-meter.component';
import { StackBarHorizontalIIComponent } from '../../components/shared/chart/stack-bar-horizontal-ii/stack-bar-horizontal-ii.component';
import { LoaderInterceptorService } from 'src/app/core/loader.interceptor';
import { LoaderComponent } from 'src/app/components/shared/loader/loader.component';
import { LoaderService } from 'src/app/core/loader.service';
import { BarChartLineValue_IComponent } from '../../components/shared/chart/bar-chart-line-value-i/bar-chart-line-value-i.component';
import { DualChartWithLine_IComponent } from '../../components/shared/chart/dual-with-line-i/dual-with-line-i.component';
import { CustomBarComponent } from '../../components/shared/chart/custom-bar/custom-bar.component';
import { StackBarHorizontalIIIComponent } from '../../components/shared/chart/stack-bar-horizontal-iii/stack-bar-horizontal-iii.component';
import { SimpleBarChartIIComponent } from '../../components/shared/chart/simple-bar-chart-ii/simple-bar-chart.component-ii';
import { MapTHComponent } from 'src/app/components/shared/map-th/map-th.component';
import { DualChartWithLine_IIComponent } from '../../components/shared/chart/dual-with-line-ii/dual-with-line-ii.component';
import { DualChartWithDoubleLineComponent } from '../../components/shared/chart/dual-with-double-line/dual-with-double-line.component';
import { Line_II_ChartComponent } from '../../components/shared/chart/line-ii-chart/line-ii-chart.component';
import { GuageVChartComponent } from '../../components/shared/chart/guage-v-chart/guage-v-chart.component';
import { SimpleBarChartIIIComponent } from '../../components/shared/chart/simple-bar-chart-iii/simple-bar-chart-iii.component';
import { DonutChartIComponent } from '../../components/shared/chart/donut-chart-i/donut-chart-i.component';
import { SimpleBarChartIIIIComponent } from '../../components/shared/chart/simple-bar-chart-iiii/simple-bar-chart-iiii.component';
import { BarWithLineSingleIComponent } from '../../components/shared/chart/bar-with-line-single-i/bar-with-line-single-i.component';
import { StackBarLineIComponent } from '../../components/shared/chart/stack-bar-line-i/stack-bar-line-i.component';
import { DualDoubleChartComponent } from '../../components/shared/chart/dual-double-chart/dual-double-chart.component';
import { SimpleBarChartVComponent } from '../../components/shared/chart/simple-bar-chart-v/simple-bar-chart-v.component';
import { AlertModalComponent } from '../../components/shared/modal/alert-modal.component';
import { InfoModalComponent } from '../../components/shared/modal/info-modal.component';
import { WarnModalComponent } from '../../components/shared/modal/warn-modal.component';
import { ConfirmModalComponent } from '../../components/shared/modal/confirm-modal.component';

setTheme('bs4'); // or 'bs4'


@NgModule({
  declarations: [
    HeaderComponent,
    LoaderComponent,
    AutoTableComponent,
    MenuListComponent,
    AutoCompleteComponent,
    DataMonthComponent,
    FileUploadComponent,
    BarChartComponent,
    MultipleBarChartComponent,
    DualScaleComponent,
    PieChartComponent,
    BarWithLineComponent,
    BarWithLineSingleComponent,
    DoubleChartComponent,
    barChartMonthOfYear,
    MegaMenuComponent,
    MainMenuComponent,
    DealerMenuComponent,
    barWithDualLineComponent,
    SsiCsiPaymentComponent,
    DonutChartComponent,
    CustomDialogComponent,
    AutoCompleteQuerySearchComponent,
    AutoCompleteQuerySearchDialog,
    AutoCompleteDialog,
    orderByPipe,
    GraphChartComponent,
    GraphChartOneComponent,
    GraphChartThreeComponent,
    GraphChartTwoComponent,
    LineChartComponent,
    StackChartComponent,
    PaymentComponent,
    DualChartComponent,
    CardComponent,
    ReportssComponent,
    TableCardComponent,
    LocalSurveySsiComponent,
    MultipleBarChartManagementComponent,
    MultipleBarChartManagementPercenComponent,
    CircleComponent,
    PaymentMultipleComponent,
    CsmQualifyMonthlyComponent,
    PieChartComponent,
    FilterBytextPipe,

    PieChartTwoComponent,
    AutoCompleteQueryComponent,
    AutoCompleteQueryDialog,
    DialogPoComponent,
    SSIQualifiersResultComponent,
    ServiceCustomerDataQualityComponent,
    CSITargetAchievementComponent,
    StackBarChartComponent,
    NewStackBarChartComponent,
    NewDualChartComponent,
    VdmAccruedComponent,
    DualChartWithLineComponent,
    BarChart3DComponent,
    DualChart3DComponent,
    GuageIComponent,
    GuageIIComponent,
    GuageIIIComponent,
    StackBarHorizontalComponent,
    StackBarLineComponent,
    BarMutiTargetComponent,
    LineIChartComponent,
    BarChartLineValueComponent,
    SimpleBarChartComponent,
    CustomerCommentComponent,
    SystemMenuComponent,
    DialogTemplateCallerComponent,
    DialogTemplateCallerDialog,
    GuageIIIIChartComponent,
    SpeedMeterComponent,
    StackBarHorizontalIIComponent,
    BarChartLineValue_IComponent,
    DualChartWithLine_IComponent,
    CustomBarComponent,
    StackBarHorizontalIIIComponent,
    SimpleBarChartIIComponent,
    MapTHComponent,
    DualChartWithLine_IIComponent,
    DualChartWithDoubleLineComponent,
    Line_II_ChartComponent,
    GuageVChartComponent,
    SimpleBarChartIIIComponent,
    DonutChartIComponent,
    SimpleBarChartIIIIComponent,
    BarWithLineSingleIComponent,
    StackBarLineIComponent,
    DualDoubleChartComponent,
    SimpleBarChartVComponent,
    AlertModalComponent,
    InfoModalComponent,
    WarnModalComponent,
    ConfirmModalComponent

  ],
  imports: [
    CommonModule,
    HttpClientModule,
    ReactiveFormsModule,
    FormsModule,
    RouterModule,
    //ReportViewerModule,
    //Material imports
    MaterialImportModule,


    BsDatepickerModule.forRoot(),
  ],
  exports: [
    HeaderComponent,
    LoaderComponent,
    AutoTableComponent,
    MenuListComponent,
    AutoCompleteComponent,
    DataMonthComponent,
    FileUploadComponent,
    BarChartComponent,
    MultipleBarChartComponent,
    DualScaleComponent,
    PieChartComponent,
    BarWithLineComponent,
    BarWithLineSingleComponent,
    DoubleChartComponent,
    barChartMonthOfYear,
    MegaMenuComponent,
    MainMenuComponent,
    DealerMenuComponent,
    barWithDualLineComponent,
    SsiCsiPaymentComponent,
    DonutChartComponent,
    GraphChartComponent,
    GraphChartOneComponent,
    GraphChartThreeComponent,
    GraphChartTwoComponent,
    LineChartComponent,
    StackChartComponent,
    AutoCompleteQuerySearchComponent,
    PaymentComponent,
    DualChartComponent,
    CardComponent,
    TableCardComponent,
    LocalSurveySsiComponent,
    ReportssComponent,
    MultipleBarChartManagementComponent,
    MultipleBarChartManagementPercenComponent,
    CircleComponent,
    PaymentMultipleComponent,
    CsmQualifyMonthlyComponent,
    PieChartComponent,
    FilterBytextPipe,

    AutoCompleteQueryComponent,
    NewStackBarChartComponent,
    NewDualChartComponent,
    VdmAccruedComponent,
    DualChartWithLineComponent,
    BarChart3DComponent,
    DualChart3DComponent,
    GuageIComponent,
    GuageIIComponent,
    GuageIIIComponent,
    StackBarHorizontalComponent,
    StackBarLineComponent,
    BarMutiTargetComponent,
    LineIChartComponent,
    BarChartLineValueComponent,
    SimpleBarChartComponent,
    CustomerCommentComponent,
    SystemMenuComponent,
    DialogTemplateCallerComponent,
    DialogTemplateCallerDialog,
    GuageIIIIChartComponent,
    SpeedMeterComponent,
    StackBarHorizontalIIComponent,
    BarChartLineValue_IComponent,
    DualChartWithLine_IComponent,
    CustomBarComponent,
    StackBarHorizontalIIIComponent,
    SimpleBarChartIIComponent,
    MapTHComponent,
    DualChartWithLine_IIComponent,
    DualChartWithDoubleLineComponent,
    Line_II_ChartComponent,
    GuageVChartComponent,
    SimpleBarChartIIIComponent,
    DonutChartIComponent,
    SimpleBarChartIIIIComponent,
    BarWithLineSingleIComponent,
    StackBarLineIComponent,
    DualDoubleChartComponent,
    SimpleBarChartVComponent
  ],
  entryComponents: [CustomDialogComponent, AutoCompleteQuerySearchDialog, AutoCompleteDialog, AutoCompleteQueryDialog, DialogTemplateCallerDialog
    , AlertModalComponent,
    InfoModalComponent,
    WarnModalComponent,
    ConfirmModalComponent],
  providers: [
    HttpService,
    Globals,
    AuthDecode,
    LoaderService,
    TokenInterceptor,
    {
      provide: HTTP_INTERCEPTORS,
      useClass: TokenInterceptor,
      multi: true
    }
  ],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class SharedComponentModule { }
