import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'filterBytext'
})
export class FilterBytextPipe implements PipeTransform {

  transform(items: any[], prop: string, searchText: string): any {

    if (!items) return [];
    if (!searchText) return items;
   // if (items == null) return [];
    //searchText = searchText.toLocaleLowerCase();
    return items.filter(item => item[prop].toString().indexOf(searchText) !== -1);
  }
}


@Pipe({
  name: 'orderBy'
})
export class orderByPipe implements PipeTransform {

  transform(array : any [], orderBy : string, asc = true) {

    if (!orderBy || orderBy.trim() == "") {
      return array;
    }

    if (asc) {
      return array.sort((item1: any, item2: any) => {
        return this.orderByComparator(item1[orderBy], item2[orderBy]);
      });
    }
    else {

      return array.sort((item1: any, item2: any) => {
        return this.orderByComparator(item2[orderBy], item1[orderBy]);
      });
    }

  }

  orderByComparator(a: any, b: any): number {

    if ((isNaN(parseFloat(a)) || !isFinite(a)) || (isNaN(parseFloat(b)) || !isFinite(b))) {
      if (a < b) return -1;
      if (a > b) return 1;
    }
    else {
      if (parseFloat(a) < parseFloat(b)) return -1;
      if (parseFloat(a) > parseFloat(b)) return 1;
    }

    return 0;
  }
}
