import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { HttpService } from 'src/app/core/http.service';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';

@Component({
    selector: 'rpt',
    //template: '<a href="" style="display: none;" #downloadTrigger></a>' 
    templateUrl: './RPT.component.html'
})
export class RPTComponent implements OnInit {
    private reportName: string = "";
    @ViewChild("downloadTrigger", { static: false }) downloadTrigger: ElementRef;
    @ViewChild("frame", { static: false }) frame: ElementRef;

    safeSrc: SafeResourceUrl;
    constructor(
        private route: ActivatedRoute,
        private http: HttpService,
        private sanitizer : DomSanitizer
        
    ) {
        //route.paramMap.subscribe(pm => {
        //    this.parameter_type = pm.get('PARAMETER_TYPE')
        //    this.reportName = pm.get('reportName');
        //})

    }

    private origin: string = window.location.protocol + "//" + window.location.hostname + ":8090/";
    private REPORT_PATH: string = '/WSYS/Report.aspx?'
    private FullPath: string;

    ngOnInit(): void {
        //this.exportReport();
        this.ShowReport()

    }

    ngAfterViewInit() {

    }

    ShowReport() {

        let url_string = window.location.href
        let url = new URL(url_string);
        let reportName = url.searchParams.get("reportName");
        let paraMeterType = url.searchParams.get("paraMeterType");

        let Param = this.Setparameter(reportName, paraMeterType)
        this.FullPath = this.origin + this.REPORT_PATH + 'rt=1&rc=' + reportName + '&p1=' + Param;
        this.safeSrc = this.sanitizer.bypassSecurityTrustResourceUrl(this.FullPath);
    }

    Setparameter(reportName : string, paraMeterType: string) {

        let d = new Date()
        let param: string;

        if (paraMeterType == 'FY') {

            if (reportName == 'VME_Rpt_VDM_CSI_Focus_Process' || 'VME_Rpt_VDM_SSI_Focus_Process') {

                param = d.getFullYear().toString()

            } else {
                param = d.getFullYear().toString().substring(2, 4)

            }

        } else if (paraMeterType == 'DATA_MONTH') {

            let y = d.getFullYear()
            let m = d.getMonth() + 1
            let newMonth = m.toString().length < 2 ? 0 + '' + m : m
            param = y.toString() + '' + newMonth.toString()

        } else {

            param = ''
        }

        return param;
    }

    exportReport() {
        let reportType = "EXCELOPENXML";
        let pathToRequest = "GetReport".concat("/", reportType, "/", this.reportName);
        let data = []
        this.http.postGetReport("Report", pathToRequest, data)
            .subscribe(data => {
                console.log(data);
                const blob = new Blob([data], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' });
                const url = window.URL.createObjectURL(blob);

                this.downloadTrigger.nativeElement.href = url;
                this.downloadTrigger.nativeElement.setAttribute("download", this.reportName.concat(".xlsx"));

                this.downloadTrigger.nativeElement.click();
            })
    }
}
