import { Component, EventEmitter, OnInit, SimpleChanges, OnChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { valueModel } from '../../components/shared/Template/local-survey-ssi/local-survey-ssi.component';
import * as D3 from 'd3';

@Component({
  selector: 'main-i',
  templateUrl: './main-i.component.html',
  styleUrls: ['./main-i.component.css']
})


export class MainIComponent implements OnInit, OnChanges {

  clickMessage = '';
  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals,
  ) { }

  private FY: any;
  private qRefresh: string;
  private header: string;
  public ID: string = "LocalSuvey";
  private showLine: boolean = false;

  private margin = { top: 30, right: 20, bottom: 40, left: 55 }
  private width = 300 - this.margin.left - this.margin.right
  private height = 240 - this.margin.top - this.margin.bottom;

  private TypeChart: string = "Value";
  private svg: any;

  private yScale: any;
  private xScale: any;
  private xAxis: any;
  private yAxis: any;
  private chart: any;
  private chartTitle: string;
  private barGroups: any;

  public chartColor: string;
  public data1: any = [];

  public data2: any = [];
  public selectData: any = {};
  public tableData: any = [];
  public selectData2: any = {};

  public filterData: any = {};

  selectedRow: Number;
  setClickedRow: Function;
  public data1Total: any = {};
  private DATA_MONTH: string;
  private Month: string;
  public selectrow;
  public selectedName: any;

  public FY_N: any;
  public dataDealer: any;
  public OutletList: any = [];
  public qShowChart: boolean = true;
  public qShowQuarter: boolean = true;
  public qShowMonthly: boolean;

  private labelxScalemonth12 = ["Consultation", "Product Presentation", "Test Drive", "Follow up"];
  private labelxScalemonth12_CSI = ["Consultation", "Product Presentation", "Test Drive", "Follow up"];

  private d3: any = D3;
  public showMenu: boolean = true;


  ngOnInit(): void {

    this.FY = '20';

    this.filterData.PERIOD = 'Monthly';
    this.filterData.MONTH = 'April';
    this.filterData.YEAR = '2020';
    this.filterData.REPORT = 'Demand/Supply';
    this.qShowMonthly = true;

    this.FY_N = "20" + (+this.FY + 1);

    this.dataDealer = {};
    this.data1Total = {};

    this.DATA_MONTH = '202004';
    //this.GetData();

  }

  ngAfterViewInit() {
    this.SetupChart(this.ID)
    this.GetData();
  }

  ngOnChanges(changes: SimpleChanges): void {
    if (!changes["qRefresh"].isFirstChange()) {
      this.d3.select("#" + 'barchart' + this.ID).remove();
      this.SetupChart(this.ID);
      this.GetData();
    }
  }


  public ShowDataAs(pValue) {
    if (pValue == 'Section') {
      return 'Region';
    } else if (pValue == 'Region') {
      return 'Area (Sale,Aftersale)';
    } else {
      return pValue;
    }

  }

  private GetCurrentFY() {
    let _date = new Date();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;

    if (month <= 3) {
      year = year - 1;
    }
    return year - 2000;
  }

  public Filter_Selected(pType, pValue) {

    if (pType == 'TYPE') {
      this.filterData.DATA_TYPE = pValue;

    } else if (pType == 'AS') {
      this.filterData.DATA_AS = pValue;
      if (pValue == 'Outlet') {
        this.filterData.REGION_B = 'R1-1';
        this.dataDealer.OUTLET_ID = 0;
      }
    } else if (pType == 'Region') {
      this.filterData.REGION = pValue;
    } else if (pType == 'RegionB') {
      this.filterData.REGION_B = pValue;
      this.dataDealer.OUTLET_ID = 0;
    } else if (pType == 'Section') {
      this.filterData.SECTION = pValue;
    } else if (pType == 'Outlet') {
      this.dataDealer.OUTLET_ID = 0;
    } else if (pType == 'P') {
      console.log('March : ' + pValue);
      this.filterData.PERIOD = pValue;
      this.qShowMonthly = true;
      if (pValue == 'R3M') {
        this.filterData.MONTH = 'June';
        this.Month = '06';

      } else if (pValue == 'R6M') {
        this.Month = '09';
        this.filterData.MONTH = 'September';
      }

    } else if (pType == 'M') {
      this.filterData.MONTH = pValue;

      if (pValue == 'April') {
        this.Month = '04';
      } else if (pValue == 'May') {
        this.Month = '05';
      } else if (pValue == 'June') {
        this.Month = '06';
      } else if (pValue == 'July') {
        this.Month = '07';
      } else if (pValue == 'August') {
        this.Month = '08';
      } else if (pValue == 'September') {
        this.Month = '09';
      } else if (pValue == 'October') {
        this.Month = '10';
      } else if (pValue == 'November') {
        this.Month = '11';
      } else if (pValue == 'December') {
        this.Month = '12';
      }

      this.DATA_MONTH = "20" + this.FY + this.Month;

      if (pValue == 'January') {
        this.Month = '01';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      } else if (pValue == 'February') {
        this.Month = '02';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      } else if (pValue == 'March') {
        this.Month = '03';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      }
    }

    //---- if month change, do not refresh data
    if (pType == 'M') {
      this.selectData = this.data1.find(x => x.DATA_MONTH == this.DATA_MONTH)
      this.ViewData(this.selectData);

    } else {
      this.GetData();
    }

  }


  private GetData() {

    var sendData: any;
    sendData = {};
    sendData.DATA_MONTH = this.DATA_MONTH;


    this.http.post("wPMS", "DASH_IC_DS_INFO", JSON.stringify(sendData))
      .subscribe((result: any) => {
        this.data1 = result.Table;
        this.selectData = this.data1.find(x => x.DATA_MONTH == this.DATA_MONTH);
        this.selectedName = this.selectData.DATA_MONTHNAME;
      //  console.log('this.selectData : ', this.selectData);

        this.ViewData(this.data1);
        //console.log('DASH_IC_DS_INFO : ', result.Table);
      })

    //this.data1 = JSON.parse('[{ "DATA_MONTH": "202004", "DATA_MONTHNAME": "Apr-20", "catagory": "Apr", "OS_TARGET": 9.68, "CAT1": 9.87, "CAT2": 9.9, "CAT3": 9.73, "CAT4": 9.13, "CAT5": 9.53, "CAT6": 9.63, "CAT7": 9.93, "CAT8": 9.63, "CAT9": 9.43, "CAT10": 9.23, "CAT11": 9.8, "CAT12": 9.2} , { "DATA_MONTH": "202005", "DATA_MONTHNAME": "May-20", "catagory": "May", "OS_TARGET": 9.28, "CAT1": 9.87, "CAT2": 9.7, "CAT3": 9.63, "CAT4": 9.44, "CAT5": 9.85, "CAT6": 9.55, "CAT7": 9.63, "CAT8": 9.42, "CAT9": 9.17, "CAT10": 9.59, "CAT11": 9.65, "CAT12": 9.63 } , { "DATA_MONTH": "202006", "DATA_MONTHNAME": "Jun-20", "catagory": "Jun", "OS_TARGET": 9.48, "CAT1": 9.87, "CAT2": 9.7, "CAT3": 9.92, "CAT4": 9.78, "CAT5": 9.63, "CAT6": 9.21, "CAT7": 9.58, "CAT8": 9.86, "CAT9": 9.63, "CAT10": 9.71, "CAT11": 9.60, "CAT12": 9.23 }]');

    //console.log('this.data1 : ', this.data1);
    //this.selectData = this.data1.slice() ; //' this.data1.find(x => x.DATA_MONTH == this.DATA_MONTH)

    //console.log('this.selectData : ', this.selectData);



  }


  public ViewData(data) {
    
    if (data != undefined && data! + '') {
      this.qShowChart = true;

      var chartData: any = data;

      //var chartData: any = [
      //  { catagory: "CAT 1", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 2", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 3", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 4", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 5", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 6", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 7", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 8", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 9", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 10", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 11", Value: data.Value, Target: data.Target }
      //  , { catagory: "CAT 12", Value: data.Value, Target: data.Target }

      //];

      this.tableData = chartData;
      //console.log('this.tableData :', this.tableData);

      this.labelxScalemonth12 = ["CAT 1", "CAT 2", "CAT 3", "CAT 4", "CAT 5", "CAT 6", "CAT 7", "CAT 8", "CAT 9", "CAT 10", "CAT 11", "CAT 12"];
      this.chartTitle = 'Demand/Supply';

      console.log('chartData : ', chartData);
      this.CreateChart(chartData);
      this.DATA_MONTH = data.DATA_MONTH;
      this.selectedName = data.DATA_MONTHNAME;

    } else {
      this.qShowChart = false;
    }

  }

  public highlightRow(data) {
    this.selectedName = data.DATA_MONTHNAME;
  }

  public GetFormateDate() {
    let _date = new Date();
    let day = _date.getDate();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;

    if (day >= 15) {

      month = month - 1;
      if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }
    else {
      month = month - 2;
      if (month == -1) {
        month = 11;
        year = year - 1;
      } else if (month == 0) {
        month = 12;
        year = year - 1;
      }
    }

    let newMonth = month.toString().length < 2 ? 0 + '' + month : month

    return year + '' + newMonth

  }


  //-----------------------------------------
  private SetupChart(id) {

    width = 900;
    if (width == null) {
      width = 800 - margin.left - margin.right
    }
    height = 260;
    if (height == null) {
      height = 350 - margin.top - margin.bottom
    }
    var margin = { top: 30, right: 20, bottom: 40, left: 40 },
      width = width - margin.left - margin.right,
      height = height - margin.top - margin.bottom;


    this.svg = this.d3.select('#' + id).append('svg')
      .attr("id", + 'barchart' + this.ID)
      .attr('width', width + margin.left + margin.right)
      .attr('height', height + margin.top + margin.bottom)
      .style("background", "rgb(255, 255, 255");


    this.yScale = this.d3.scaleLinear()
      .range([height - 50, 0])


    this.xScale = this.d3.scaleBand()
      .range([0, width])
      .paddingInner(0.35)
      .paddingOuter(0.1)

    this.xAxis = this.d3.axisBottom(this.xScale);
    this.yAxis = this.d3.axisLeft(this.yScale).ticks(5)


    this.chart = this.svg.append('g')
      .attr('transform', `translate(${margin.left}, ${margin.top})`);

    this.chart.append('g')
      .attr("class", "y axis2")
      .call(this.yAxis);

    this.chart.append('g')
      .attr("class", "xAxis")
      .attr('transform', `translate(0, ${height - 50})`)
      .call(this.xAxis)
      .selectAll("text")
      .style("text-anchor", "end")

    // this.GetData()

  }


  private CreateChart(gData) {

    width = 900;
    if (width == null) {
      width = 550 - margin.left - margin.right
    }

    height = 260;
    if (height == null) {
      height = 350 - margin.top - margin.bottom;
    }

    var margin = { top: 30, right: 20, bottom: 40, left: 40 },
      width = width - margin.left - margin.right,
      height = height - margin.top - margin.bottom;


    let data: valueModel[];
    data = gData

    var yMinDomain = this.GenerateYminDomain(data)
    var yMaxDomain = this.GenerateYmaxDomain(data)


    this.yScale.domain([yMinDomain, yMaxDomain])
    this.xScale.domain(this.labelxScalemonth12.map(d => d))

    this.chart
      .select(".y")
      .call(this.yAxis);

    this.chart
      .select(".xAxis")
      .attr('transform', `translate(0, ${height - 50})`)
      .call(this.xAxis)
      .selectAll("text")
      //.attr("dx", "-45px")
      //.attr("dy", "8px")
      .style("text-anchor", "end")
      // .attr('transform', (d) => `translate( ${this.xScale(d.catagory)}, 20)`)
      .attr("transform", (d) => "rotate(-55)");




    var line = this.d3.line()
      .x((d) => {
        return (this.xScale(d.catagory) + this.xScale.bandwidth() / 2);
      })
      .y((d) => {
        return this.yScale(d.Target);
      })
      .defined((d) => d.Target != 0);


    //create range of grid line from yScale
    this.svg.select('.grid').remove();//remove then create new because each data had scale of it.
    var makeYLines = () => this.d3.axisLeft(this.yScale);
    this.chart.append('g')
      .attr('class', 'grid')
      .call(makeYLines().ticks(5).tickSize(-width).tickFormat((d) => ""));

    let xScaleOfBar = this.xScale;
    let yScaleOfBar = this.yScale;

    let chart = this.chart;
    this.barGroups = this.chart.selectAll(".bar2")
      .data(data)

    this.barGroups
      .enter()
      .append("rect")
      .merge(this.barGroups)
      .attr("class", "bar2")
      //.transition().duration(100)
      .attr('x', (d) => this.xScale(d.catagory) + 5)
      .attr('y', (d) => this.yScale(d.Value > 0 ? d.Value : 0))
      .attr('height', (s) => height - this.yScale(s.Value) - 50)
      .attr('width', this.xScale.bandwidth() - 10)
      .attr("fill",
        (d) => {
          return '#6dd0d6';
        })

    this.barGroups = this.chart.selectAll(".textvalue2")
      .remove()
      .exit()
      .data(data)

    var formatDecimalComma = D3.format(",.2f");

    this.barGroups
      .enter()
      .append('text')
      .attr('class', 'textvalue2')
      .attr('x', (d) => this.xScale(d.catagory) + this.xScale.bandwidth() / 2)
      .attr('y', (d) => this.yScale(d.Value) - 15)
      .attr('text-anchor', 'middle')
      .attr("fill", "#000000")
      .attr("font-size", "13.5")
      .text((d) => d.Value > 0 ? formatDecimalComma(d.Value) : '')


    this.chart.selectAll(".linev1")
      .remove()
      .exit()

    // Add the line path.
    var lineV = this.chart.append("path")
      .attr("class", "linev1")
      .attr("fill", "none")
      .attr("stroke-width", 1.5)
      .attr("d", line(data))
      .attr("stroke", 'red')
      .attr("shape-rendering", "geometricPrecision")


    var totalLength = lineV.node().getTotalLength();

    lineV.attr("stroke-dasharray", totalLength + " " + totalLength)
      .attr("stroke-dashoffset", totalLength)
      .transition(this.d3.linear)
      .duration(2000)
      .attr("stroke-dashoffset", 0);

    this.chart.selectAll("circle")
      .remove()
      .exit()

    this.chart.selectAll('circle')
      .data(data)
      .enter()
      .append('circle')
      .attr('fill', '#ffffff')
      .attr('stroke', 'red')
      .attr('cx', (d) => (this.xScale(d.catagory) + this.xScale.bandwidth() / 2))
      .attr('cy', (d) => this.yScale(d.Target))
      .attr('r', 3)


    this.svg.select('.textH').remove()

    this.chart.append('text')
      .attr('class', 'textH')
      .attr('x', width / 2)
      .attr('y', -12)
      .style("font-size", "16")
      .attr('text-anchor', 'middle')
      .style("font-weight", 'bold')
      .style("fill", "black")
      .text(this.chartTitle)
  }

  //------- 2 --------------

  //------------------------
  GenerateYmaxDomain(data: valueModel[]) {

    var yMaxDomain: number;

    if (this.TypeChart == 'Value') {

      yMaxDomain = this.d3.max(data, d => Number(d.Value))

    } else {

      yMaxDomain = 100;
    }
    //yMaxDomain = 11;
    return yMaxDomain
  }

  GenerateYminDomain(data: valueModel[]) {
    var yMinDomain: number = 5;
    return yMinDomain
  }

  GenerateHearderList(data) {
    let newData = [];
    for (var key in data[0]) {
      if (key != 'FY' && key != 'catagory' && key != 'Value') {
        newData.push(key)
      }

    }
    return newData
  }

  ExportReport() {
    console.log(this.selectData.DATA_MONTH,'Data.MONTH ')
    this.global.GoToReport(
      "PMS_Rpt_Dash_Demand_Supply",
      {
        P_DATA_MONTH:this.selectData.DATA_MONTH
      })
  }

}

