import { Component, OnInit, SimpleChanges, OnChanges, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatDialog } from '@angular/material/dialog';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import * as moment from 'moment';

@Component({
  selector: 'main',
  templateUrl: './main.component.html',
  styleUrls: ['./main.component.css']
})


export class MainComponent implements OnInit, OnChanges {

  clickMessage = '';
  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private dialog: MatDialog
  ) { }

  reportServer: string = 'http://localhost/ReportServer_SQL2012';


  public DataMonthFY: any;
  public DataQuarter: string;
  public dateDefualt: string;
  public chrtWidth: number = 980;

  public DATA_MONTH: string;
  public success: boolean = false;

  public dataOS: any = [];
  public dataNPS: any = [];
  public dataNPS_CSI: any = [];
  public dataDLR: any = [];

  public dataSSI: any = [];
  public dataCSI: any = [];

  public dFromDate: moment.Moment;
  public dToDate: moment.Moment;

  public config: any;

  public filterData: any = {};

  private animal: any;
  public YearList: any = [];
  public Month: string;
  public Year: string;
  public qmonth: any;
  public QTR: string;
  public NewFY: any;
  public YearFY: any;
  public FY: string;
  public data1Total: any = {};

  public rawData: any;
  public data: any;

  public vdmServiceName: string = '';
  public qRefresh1: string = '';

  public qShowFY: boolean;
  public qShowQuarter: boolean;
  public qShowMonthly: boolean;
  public qShowR3M: boolean;
  public qShowR6M: boolean;
  public qShowFYTD: boolean;
  public qReady: boolean = false;
  public ShowQ: string = 'Q';

  public vdmType: string;

  public staffList: any = [];
  public teamList: any = [];
  //--- new -----------

  public OVERALL_SSI_INDEX: number = 0;
  public OVERALL_CSI_INDEX: number = 0;

  public dataSSICompare: any = []
  public dataCSICompare: any = []
  public ShowSSIInsight: boolean = false;
  public ShowCSIInsight: boolean = false;


  public highlight: boolean = false;
  public CompareHightlight: string;
  public ChartId: string;
  public showMenu: boolean = true

  public FY_N: any;


  public legend: any = [];
  public dataSet1: any = [];
  public dataSet2: any = [];
  public dataSet3: any = [];

  public ConfigVendorStaff: any = {
    ColName: "LOOKUP_STAFF_NAME",
    PlaceholderText: "Select Vendor Staff",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorStaff",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  ngOnInit(): void {
    this.config = {
      minDate: '201905',
      maxDate: '201905',
      ShowTwoPicker: false
    }

    this.dFromDate = moment().locale("en")
    this.dToDate = moment().locale("en")

    this.legend = [{ legend: "Accept", color: '#22de8c' }, { legend: "Shipped", color: '#909090' }];

    this.FY = '20'; // this.GetCurrentFY().toString();
    this.DATA_MONTH = '202004';// this.GetCurrentDataMonth();
    this.data1Total = {};

    this.filterData.DATA_AS = 'Nationwide';
    this.filterData.PERIOD = 'Overall';
    this.filterData.MONTH = 'April';
    this.filterData.YEAR = '2020';
    this.filterData.REPORT = 'SSI/CSI Insights';
    this.filterData.REGION = 'Region 1';
    this.filterData.REGION_B = 'R1-1';
    this.filterData.SECTION = 'CENTRAL';
    this.CompareHightlight = this.filterData.SECTION;

    this.SetDefaultYear();

    this.FY_N = "20" + (+this.FY + 1);
    this.GetData();

    var nRecord = '50';
    this.http.get('wPMS', 'GetVendorStaff', 'NULL', nRecord)
      .subscribe(result => {
        this.staffList = result.Table;

      })

    this.http.get('wPMS', 'GetVendorStaffTeam', 'NULL', nRecord)
      .subscribe(result => {
        this.teamList = result.Table;

      })
  }

  ngOnChanges(changes: SimpleChanges): void {

  }

  public ShowDataAs(pValue) {
    if (pValue == 'Section') {
      return 'Region';
    } else if (pValue == 'Region') {
      return 'Area (Sale,Aftersale)';
    } else {
      return pValue;
    }
  }

  public Goto(url) {
    this.router.navigate([url]);
  }

  private DateToString(pDate) {

    let day = pDate.getDate();
    let year = pDate.getFullYear()
    let month = pDate.getMonth() + 1;
    let newMonth = month.toString().length < 2 ? 0 + '' + month : month;

    this.Month = newMonth.toString();
    return day + '-' + this.GetMonthName(newMonth) + '-' + year;
  }

  private MomentToString(pDate) {
    return pDate.format("DD") + '-' + pDate.format("MMM") + '-' + pDate.format("YY");
  }

  public DataMonthAdd(pDataMonth, pInterval: number) {

    var newMonth: number = pDataMonth.substring(4, 6);
    var newYear: number;

    if (newYear + pInterval <= 0) {
      newMonth = +newMonth + pInterval + 12;
      newYear = +pDataMonth.substring(0, 4) - 1;
    } else if (newYear + pInterval > 12) {
      newMonth = +newMonth + pInterval - 12;
      newYear = +pDataMonth.substring(0, 4) + 1;
    } else {
      newMonth = +newMonth + 0 + pInterval;
      newYear = +pDataMonth.substring(0, 4);
    }

    if (newMonth < 10) {
      return newYear + '0' + newMonth;
    } else {
      return newYear + '' + newMonth;
    }
  }

  private GetMonthName(pValue) {

    var returnValue;

    if (pValue == '04') {
      returnValue = 'Apr';
    } else if (pValue == '05') {
      returnValue = 'May';
    } else if (pValue == '06') {
      returnValue = 'Jun';
    } else if (pValue == '07') {
      returnValue = 'Jul';
    } else if (pValue == '08') {
      returnValue = 'Aug';
    } else if (pValue == '09') {
      returnValue = 'Sep';
    } else if (pValue == '10') {
      returnValue = 'Oct';
    } else if (pValue == '11') {
      returnValue = 'Nov';
    } else if (pValue == '12') {
      returnValue = 'Dec';
    } else if (pValue == '01') {
      returnValue = 'Jan';
    } else if (pValue == '02') {
      returnValue = 'Feb';
    } else if (pValue == '03') {
      returnValue = 'Mar';
    }
    return returnValue;
  }

  private SetRefresh1() {
    this.qRefresh1 = this.filterData.DATA_AS +
      this.filterData.PERIOD +
      this.filterData.MONTH +
      this.filterData.YEAR +
      this.filterData.REPORT +
      this.filterData.REGION +
      this.filterData.REGION_B +
      this.filterData.SECTION;
  }

  public Filter_Selected(pType, pValue) {

    if (pType == 'AS') {
      this.filterData.DATA_AS = pValue;
      if (pValue == 'Region') {
        this.CompareHightlight = this.filterData.REGION
      } else if (pValue == 'Section') {
        this.CompareHightlight = this.filterData.SECTION
      }
    }
    else if (pType == 'REPORT') {
      this.filterData.REPORT = pValue;

      this.qShowFY = true;
      this.qShowQuarter = true;
      this.qShowMonthly = true;


    }
    else if (pType == 'P') {
      this.filterData.PERIOD = pValue;
      this.qShowMonthly = true;

      if (pValue == 'Overall') {

      } else if (pValue == 'PIC') {

      } else if (pValue == 'Team') {

      }


    }
    else if (pType == 'FY') {
      this.FY = pValue;

    }
    else if (pType == 'M') {
      this.filterData.MONTH = pValue;

      if (pValue == 'April') {
        this.Month = '04';
      } else if (pValue == 'May') {
        this.Month = '05';
      } else if (pValue == 'June') {
        this.Month = '06';
      } else if (pValue == 'July') {
        this.Month = '07';
      } else if (pValue == 'August') {
        this.Month = '08';
      } else if (pValue == 'September') {
        this.Month = '09';
      } else if (pValue == 'October') {
        this.Month = '10';
      } else if (pValue == 'November') {
        this.Month = '11';
      } else if (pValue == 'December') {
        this.Month = '12';
      }

      this.DATA_MONTH = "20" + this.FY + this.Month;

      if (pValue == 'January') {
        this.Month = '01';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      } else if (pValue == 'February') {
        this.Month = '02';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      } else if (pValue == 'March') {
        this.Month = '03';
        this.DATA_MONTH = "20" + (+this.FY + 1) + this.Month;
      }

    }

    else if (pType == 'Q') {
      this.QTR = pValue;

      if (pValue == '1') {
        this.QTR = '1';
      }
      if (pValue == '2') {
        this.QTR = '2';
      }
      if (pValue == '3') {
        this.QTR = '3';
      }
      if (pValue == '4') {
        this.QTR = '4';
      }


    } else if (pType == 'TYPE') {
      this.filterData.DATA_TYPE = pValue;

    } else if (pType == 'AS') {
      this.filterData.DATA_AS = pValue;

    } else if (pType == 'Region') {
      this.filterData.REGION = pValue;


    } else if (pType == 'Section') {
      this.filterData.SECTION = pValue;
      this.CompareHightlight = this.filterData.SECTION
    } else if (pType == 'Region') {
      this.filterData.REGION = pValue;
    } else if (pType == 'RegionB') {
      this.filterData.REGION_B = pValue;
    }

    this.GetData();

  }


  public StaffChange(event) {
    this.filterData.SK_USER_ID = event.STAFF_ID;

    this.filterData.ENAME = event.ENAME;
    this.filterData.TNAME = event.TNAME;
    this.GetData();
  }

  public TeamChange(event) {
    this.filterData.TEAM_ID = event.TEAM_ID;
    this.GetData();
  }

  public VendorTypeChange(type, names) {
    this.filterData.VENDOR_TYPE = type;
    this.filterData.VENDOR_TYPE_NAME = names;
    this.GetData();
  }


  SetDefaultYear() {
    let YearDeflaut = 2019;
    let d = new Date();
    let y = d.getFullYear();
    let index = y - YearDeflaut;
    for (let i = 0; i <= index; i++) {
      let y = YearDeflaut + i
      this.YearList.push(y.toString())
    }
  }

  RandomText() {

    let r = Math.random().toString(36).substring(7);
    return r
  }

  DateChange(date) {
    this.DATA_MONTH = date;

  }

  selectFY() {
    this.YearFY = Number(this.YearFY) - 2000;
    this.FY = this.YearFY;
  }

  public GetPeriod(pPeriod, pMonth) {

    var returnValue;

    if (pPeriod == 'R3M') {
      if (pMonth == 'June') {
        returnValue = 'Apr ' + this.FY + ' - Jun ' + this.FY;
      }
      else if (pMonth == 'July') {
        returnValue = 'May ' + this.FY + ' - Jul ' + this.FY;
      }
      else if (pMonth == 'August') {
        returnValue = 'Jun ' + this.FY + ' - Aug ' + this.FY;
      }
      else if (pMonth == 'September') {
        returnValue = 'Jul ' + this.FY + ' - Sep ' + this.FY;
      }
      else if (pMonth == 'October') {
        returnValue = 'Aug ' + this.FY + ' - Oct ' + this.FY;
      }
      else if (pMonth == 'November') {
        returnValue = 'Sep ' + this.FY + ' - Nov ' + this.FY;
      }
      else if (pMonth == 'December') {
        returnValue = 'Oct ' + this.FY + ' - Dec ' + this.FY;
      }
      else if (pMonth == 'January') {
        returnValue = 'Nov ' + this.FY + ' - Jan ' + (+this.FY + 1);
      }
      else if (pMonth == 'February') {
        returnValue = 'Dec ' + this.FY + ' - Feb ' + (+this.FY + 1);
      }
      else if (pMonth == 'March') {
        returnValue = 'Jan ' + (+this.FY + 1) + ' - Mar ' + (+this.FY + 1);
      }


    } else if (pPeriod == 'R6M') {
      if (pMonth === 'September') {
        returnValue = 'Apr ' + this.FY + ' - Sep ' + this.FY;
      }
      else if (pMonth == 'October') {
        returnValue = 'May ' + this.FY + ' - Oct ' + this.FY;
      }
      else if (pMonth == 'November') {
        returnValue = 'Jun ' + this.FY + ' - Nov ' + this.FY;
      }
      else if (pMonth == 'December') {
        returnValue = 'Jul ' + this.FY + ' - Dec ' + this.FY;
      }
      else if (pMonth == 'January') {
        returnValue = 'Aug ' + this.FY + ' - Jan ' + (+this.FY + 1);
      }
      else if (pMonth == 'February') {
        returnValue = 'Sep ' + this.FY + ' - Feb ' + (+this.FY + 1);
      }
      else if (pMonth == 'March') {
        returnValue = 'Oct ' + this.FY + ' - Mar ' + (+this.FY + 1);
      }
    } else {
      if (pMonth == 'April') {
        returnValue = 'Apr ' + this.FY;
      }
      else if (pMonth == 'May') {
        returnValue = 'May ' + this.FY;
      }
      else if (pMonth == 'June') {
        returnValue = 'Jun ' + this.FY;
      }
      else if (pMonth === 'July') {
        returnValue = 'Jul ' + this.FY;
      }
      else if (pMonth == 'August') {
        returnValue = 'Aug ' + this.FY;
      }
      else if (pMonth == 'September') {
        returnValue = 'Sep ' + this.FY;
      }
      else if (pMonth == 'October') {
        returnValue = 'Oct ' + this.FY;
      }
      else if (pMonth == 'November') {
        returnValue = 'Nov '
      }
      else if (pMonth == 'December') {
        returnValue = 'Dec ' + this.FY;
      }
      else if (pMonth == 'January') {
        returnValue = 'Jan ' + (+this.FY + 1);
      }
      else if (pMonth == 'February') {
        returnValue = 'Feb ' + (+this.FY + 1);
      }
      else if (pMonth == 'March') {
        returnValue = 'Mar ' + (+this.FY + 1);
      }
    }
    return returnValue;
  }


  private GetData() {
    this.Date_Change();
  }

  public Date_Change() {

    var diffDays = 0;
    var dShowDate;

    if (this.dFromDate == undefined) {
      return;
    }

    if (this.dToDate == undefined) {
      return;
    }
    diffDays = this.dToDate.valueOf() - this.dFromDate.valueOf();

    diffDays = Math.ceil(diffDays / (1000 * 3600 * 24)) + 1;
    //console.log(' this.dFromDate ', this.dFromDate);
    //console.log(' diffDays ', diffDays);


    if (diffDays < 0) {
      this.modal.warning("'From Date' is more than 'To date'", this.viewRef);
      return;
    } else if (diffDays < 5) {
      this.chrtWidth = 500;
    } else if (diffDays < 9) {
      this.chrtWidth = 100 * diffDays;
    } else {
      this.chrtWidth = 1200;
    }

    // if (diffDays > 16) {
    //   this.modal.warning("The selected period is to long", this.viewRef);
    //   return;
    // }

    var sendData: any;
    sendData = {};
    sendData.START_DATE = this.global.ConvertDateToFormatSTD(this.dFromDate);
    sendData.TO_DATE = this.global.ConvertDateToFormatSTD(this.dToDate);

    this.dataSet1 = [];
    this.dataSet2 = [];
    this.dataSet3 = [];

    if (this.filterData.PERIOD == 'Overall') {
      this.http.post("wPMS", "DASH_IC_GetFR", JSON.stringify(sendData))
        .subscribe((result: any) => {
          this.dataSet1 = result.Table || [];
          this.dataSet2 = result.Table1 || [];
          this.dataSet3 = result.Table2 || [];

        })
    } else if (this.filterData.PERIOD == 'PIC' && this.filterData.SK_USER_ID != undefined && this.filterData.SK_USER_ID != null) {
      sendData.USER_ID = this.filterData.SK_USER_ID;
      this.http.post("wPMS", "DASH_IC_GetFR_Staff", JSON.stringify(sendData))
        .subscribe((result: any) => {
          this.dataSet1 = result.Table || [];
          this.dataSet2 = result.Table1 || [];
          this.dataSet3 = result.Table2 || [];
        })

    } else if (this.filterData.PERIOD == 'Team' && this.filterData.TEAM_ID) {
      sendData.TEAM_ID = this.filterData.TEAM_ID;
      this.http.post("wPMS", "DASH_IC_GetFR_Team", JSON.stringify(sendData))
        .subscribe((result: any) => {
          this.dataSet1 = result.Table || [];
          this.dataSet2 = result.Table1 || [];
          this.dataSet3 = result.Table2 || [];
        })

    } else if (this.filterData.PERIOD == 'VendorType' && this.filterData.VENDOR_TYPE != undefined && this.filterData.VENDOR_TYPE != null) {
      sendData.VENDOR_TYPE = this.filterData.VENDOR_TYPE;
      this.http.post("wPMS", "DASH_IC_GetFR_VendorType", JSON.stringify(sendData))
        .subscribe((result: any) => {
          this.dataSet1 = result.Table || [];
          this.dataSet2 = result.Table1 || [];
          this.dataSet3 = result.Table2 || [];
        })

    }




  }

  private GetRandomArbitrary(min, max) {
    return Math.random() * (max - min) + min;
  }

  private GetRandomInt(max) {
    return Math.floor(Math.random() * Math.floor(max));
  }


  Back() {
    this.ShowSSIInsight = false;
    this.ShowCSIInsight = false;
    this.highlight = false;
  }


  ExportReport(pType) {
    if (pType == "Overall") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Overall_RAW",
        {
          P_START_DATE: this.global.ConvertDateToFormatSTD(this.dFromDate),
          P_END_DATE: this.global.ConvertDateToFormatSTD(this.dToDate)
        })
    } else if (pType == "PIC") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Staff_RAW",
        {
          P_START_DATE: this.global.ConvertDateToFormatSTD(this.dFromDate),
          P_END_DATE: this.global.ConvertDateToFormatSTD(this.dToDate),
          P_STAFF_ID: this.filterData.SK_USER_ID
        })
    } else if (pType == "Team") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Team_RAW",
        {
          P_START_DATE: this.global.ConvertDateToFormatSTD(this.dFromDate),
          P_END_DATE: this.global.ConvertDateToFormatSTD(this.dToDate),
          P_TEAM_ID: this.filterData.TEAM_ID
        })
    } else if (pType == "VendorType") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_VendorType_RAW",
        {
          P_START_DATE: this.global.ConvertDateToFormatSTD(this.dFromDate),
          P_END_DATE: this.global.ConvertDateToFormatSTD(this.dToDate),
          P_VENDOR_TPYE: this.filterData.VENDOR_TYPE
        })
    }
  }

  CallReport(val) {
    let allocateDate = val.ALLOCATE_DATE;

    if (this.filterData.PERIOD == "Overall") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Overall_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate
        })
    } else if (this.filterData.PERIOD == "PIC") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Staff_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_STAFF_ID: this.filterData.SK_USER_ID
        })
    } else if (this.filterData.PERIOD == "Team") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_Team_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_TEAM_ID: this.filterData.TEAM_ID
        })
    } else if (this.filterData.PERIOD == "VendorType") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Daily_VendorType_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_VENDOR_TPYE: this.filterData.VENDOR_TYPE
        })
    }

  }

  CallReportLine(val) {
    let allocateDate = val.ALLOCATE_DATE;

    if (this.filterData.PERIOD == "Overall") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Lost_Overall_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate
        })
    } else if (this.filterData.PERIOD == "PIC") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Lost_Staff_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_STAFF_ID: this.filterData.SK_USER_ID
        })
    } else if (this.filterData.PERIOD == "Team") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Lost_Team_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_TEAM_ID: this.filterData.TEAM_ID
        })
    } else if (this.filterData.PERIOD == "VendorType") {
      this.global.GoToReport(
        "PMS_Rpt_Dash_FR_Lost_VendorType_RAW",
        {
          P_START_DATE: allocateDate,
          P_END_DATE: allocateDate,
          P_VENDOR_TPYE: this.filterData.VENDOR_TYPE
        })
    }

  }
}


