import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { PortalComponent } from './portal.component';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';

@Component({
  selector: 'role-list',
  templateUrl: './role-list.component.html',
  styleUrls: ['./role-list.component.css']
})
export class RoleListComponent extends PortalComponent {
  @Input("roles") roles: Array<any>;
  @Output() selectRole = new EventEmitter<number>();

  constructor(
    protected http: HttpService,
    protected router: Router
  ) { 
    super(http, router)
  }
  
  ngOnInit(): void {
    this.getSystemMenu();
  }
  
  getSystemMenu() {
    this.http.get("System", "GetUserRoles")
      .subscribe(result => {
        this.roles = result;
      })
  }

  roleClick(roleId: number) {
    this.selectRole.emit(roleId);
  }

}
