import { Component, EventEmitter, OnInit, SimpleChanges, OnChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';



@Component({
  selector: 'report-popup',
  templateUrl: './report-popup.component.html',
  styleUrls: ['./report-popup.component.css']
})


export class ReportPopupComponent implements OnInit {
  clickMessage = '';
  safeSrc: SafeResourceUrl;

  constructor(
    private http: HttpService,
    private router: Router,
    private sanitizer: DomSanitizer
  ) { }

  reportServer: string = 'http://localhost/ReportServer_SQL2012';

  showParameters: string = "true";
  parameters: any = { "FY": 19 };
  language: string = "en-us";
  width: number = 1000;
  height: number = 800;
  toolbar: string = "true";

  private origin: string = window.location.protocol + "//" + window.location.hostname + ":8090/";
  private REPORT_PATH: string = '/WSYS/Report.aspx?'
  private FullPath: string;

  ngOnInit(): void {
    //this.exportReport();
    console.log('start report');
    this.ShowReport()

  }

  ngAfterViewInit() {

  }

  ShowReport() {

    let url_string = window.location.href
    let url = new URL(url_string);
    let reportName = url.searchParams.get("reportName");
    let paraMeterType = url.searchParams.get("paraMeterType");

    let Param = this.Setparameter(reportName, paraMeterType)
    this.FullPath = this.origin + this.REPORT_PATH + 'rt=1&rc=' + reportName + '&p1=' + Param;
    console.log('this.FullPath : ' + this.FullPath);
    this.safeSrc = this.sanitizer.bypassSecurityTrustResourceUrl(this.FullPath);
  }

  Setparameter(reportName: string, paraMeterType: string) {

    let d = new Date()
    let param: string;

    if (paraMeterType == 'FY') {

      param = d.getFullYear().toString().substring(2, 4);

    } else if (paraMeterType == 'DATA_MONTH') {

      let y = d.getFullYear()
      let m = d.getMonth() + 1
      let newMonth = m.toString().length < 2 ? 0 + '' + m : m
      param = y.toString() + '' + newMonth.toString()

    } else if (paraMeterType == 'CUSTOM') {
      let url_string = window.location.href
      let url = new URL(url_string);
      let params = url.searchParams.get("params");
      param = params
    } else {

      param = ''
    }

    return param;
  }

}


